#==========================================================================#
#  B.Forum                                                               #
#  ץ饰 Ver.1.02                                               #
#  Encode = EUC                                                          #
#  Sakuma,Hiroaki ( sakuma@beetas.org )                                  #
#  BEETAS.org ( info@beetas.org )                                        #
#                                                                          #
# Υץꥱϥץ󥽡Ǥ.                          #
# ̵ǻѤ뤳ȤǤޤ.                                            #
# ʤ, ܺ٤ʻѾ/ǿˤĤƤϲȤ.           #
# http://www.beetas.org/                                                   #
#                                                                          #
# ------------------------------------------------------------------------ #
# Copyright 2004 Sakuma,Hiroaki All Rights Reserved.                       #
# Copyright 2004 BEETAS.org All Rights Reserved.                           #
#                                                                          #
#==========================================================================#
package Bforum::Plugin::admin;

$VERSION = "1.02";
@REQUIRE = ("1.02B-1");
@METHOD = ("admin");

use strict;
use vars qw($VERSION @REQUIRE @METHOD);

my (%in,%SET);


## ᥽å

## new
## 󥹥󥹤֤
## $obj = Bforum::Plugin::admin->new(
##    in => \%in,
##    SET => \%SET,
## );
sub new {

	my ($tmp1) = shift;
	my ($class) = ref($tmp1) || $tmp1;
	my ($self) = {};

	$self->{'in'} = {};
	$self->{'SET'} = {};

	my (%tmp2) = @_;
	foreach (keys %tmp2) {
		$self->{$_} = $tmp2{$_};
	}

	%in = %{$self->{'in'}};
	%SET = %{$self->{'SET'}};

	bless ($self, $class);

	return $self;

}

## version
## С֤
## $obj->version();
sub version {

	my ($self) = shift;

	my ($version) = "BEETAS.org ץ饰 $VERSION(" . join(",",@REQUIRE) . ")";
	return $version;

}

## require
## ưСΥå
## $obj->require($revision);
sub require {

	my ($self) = shift;
	my ($version,$revision) = @_;
	my ($tmp1) = 0;

	foreach (@REQUIRE) {
		if ($_ =~ /^($version|$revision)$/) {
			$tmp1 = 1;
			last;
		}
	}

	return $tmp1;

}

## args
## 餦
## $obj->args(
##   in => \%in,
##   SET => \%SET,
## );
sub args {

	my ($self) = shift;

	my (%args) = @_;
	foreach (keys %args) {
		$self->{$_} = $args{$_};
	}

	%in = %{$self->{'in'}};
	%SET = %{$self->{'SET'}};

	&Bforum::Plugin::admin::subs::vars(\%in,\%SET);

}



## admin
## ᥤ롼
## $obj->admin(@_);
sub admin {

	my ($self) = shift;

	my ($print);

	if (&Bforum::Plugin::admin::subs::check) {

		if ($in{'mode'} eq "plugin") {

			$print = &Bforum::Plugin::admin::subs::plugin;
			$print .= &Bforum::Plugin::admin::subs::forums;

		} elsif ($in{'mode'} eq "design") {

			if ($in{'action'} eq "show") {
				$print = &Bforum::Plugin::admin::subs::designshow;
			} elsif ($in{'action'} eq "delete") {
				$print = &Bforum::Plugin::admin::subs::designdelete;
			} elsif ($in{'action'} eq "upload") {
				$print = &Bforum::Plugin::admin::subs::designupload;
			} else {
				$print = &Bforum::Plugin::admin::subs::design;
				$print .= &Bforum::Plugin::admin::subs::forums;
			}

		} else {

			if ($in{'action'}) {
				if ($in{'admin_id'}) {
					if ($in{'action'} eq "config") {
						## ե
						$print = &Bforum::Plugin::admin::subs::config;
					} elsif ($in{'action'} eq "fdelete") {
						## եκ
						$print = &Bforum::Plugin::admin::subs::delete;
					} elsif ($in{'action'} eq "create") {
						## եκ
						$print = &Bforum::Plugin::admin::subs::create;
					} else {
						## Խ
						if ($in{'admin_t'}) {
							if ($in{'action'} eq "tdelete") {
								## åɤκ
								$print = &Bforum::Plugin::admin::subs::delete;
							} elsif ($in{'admin_m'}) {
								$print = &Bforum::Plugin::admin::subs::message;
							} elsif ($in{'action'} eq "edit") {
								$print = &Bforum::Plugin::admin::subs::thread;
							} else {
								$print = &Bforum::Plugin::admin::subs::action;
							}
						} elsif ($in{'action'} eq "tdelete") {
							$print = &Bforum::Plugin::admin::subs::index;
						} elsif ($in{'action'} eq "tselect") {
							$print = &Bforum::Plugin::admin::subs::index;
						} else {
							$print = &Bforum::Plugin::admin::subs::action;
						}
					}
				} elsif ($in{'action'} eq "create") {
					## եκ
					$print = &Bforum::Plugin::admin::subs::create;
				} elsif ($in{'action'} eq "config") {
					## Τ
					$print = &Bforum::Plugin::admin::subs::config;
				} elsif ($in{'action'} eq "fdelete") {
					$print = &Bforum::Plugin::admin::subs::forums;
				} elsif ($in{'action'} eq "fselect") {
					$print = &Bforum::Plugin::admin::subs::forums;
				} else {
					$print = &Bforum::Plugin::admin::subs::action;
				}
			} else {
				$print = &Bforum::Plugin::admin::subs::action;
			}

		}

		$print = &Bforum::Plugin::admin::subs::print($print);

		return $print;

	} elsif ($in{'password'} && !&Bforum::_use("MD5") && !&Bforum::_open(undef,"$SET{'USER_DIR'}/.passwd")) {

		##ѥɤο
		&Bforum::_write("$SET{'USER_DIR'}/.passwd",MD5->hexhash($in{'password'}));

		return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.set");

	} else {

		$print = &Bforum::Plugin::admin::subs::form;

		return $print;

	}

}



package Bforum::Plugin::admin::subs;

use vars qw(%forums %status %index %thread %message %config %plugin %design);

my (%in,%SET);

##
## check
## ѥɤå
sub check {

	if ($in{'password'} && !&Bforum::_use("MD5") && MD5->hexhash($in{'password'}) eq &Bforum::_open(undef,"$SET{'USER_DIR'}/.passwd")) {

		return 1;

	} else {

		return;

	}

}

##
## form
## եɽ
sub form {

	return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.form");

}

##
## forums
## եΰɽ
sub forums {

	my ($head) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.forums.head");
	my ($foot) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.forums.foot");
	my ($forums) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.forums");

	my ($tmp1,$tmp2);

	foreach (&Bforum::_reflexive($SET{'USER_DIR'})) {

		$_ =~ s/^$SET{'USER_DIR'}\///o;

		if (-s "$SET{'USER_DIR'}/$_/status") {
			&Bforum::_analysis(\%status,"$SET{'USER_DIR'}/$_/status");
			&Bforum::_time($status{'date'});
		} else {
			$status{'thread'} = "-";
			$status{'log'} = "-";
			$status{'date'} = "-";
		}

		$forums{'admin_id'} = $_;

		$tmp1 = $forums;
		&Bforum::do($tmp1);
		&Bforum::change($tmp1,\%status);
		&Bforum::change($tmp1,\%forums);

		$tmp2 .= $tmp1;

	}

	return $head . $tmp2 . $foot;

}

##
## index
## åɤΰɽ

sub index {

	my ($head) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.index.head");
	my ($foot) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.index.foot");
	my ($index) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.index");

	my ($tmp1,$tmp2);

	foreach (&Bforum::_open('file',"$SET{'USER_DIR'}/$in{'admin_id'}/index")) {

		chomp($_);
		$index{'admin_t'} = $_;

		$index{'number'} = &Bforum::_open('line',"$SET{'USER_DIR'}/$in{'id'}/$index{'admin_t'}/list") + 1;
		(undef,$index{'title'},$index{'author'},undef,$index{'date'},undef) = &Bforum::_analysis(undef,"$SET{'USER_DIR'}/$in{'admin_id'}/$index{'admin_t'}/1");
		&Bforum::_time($index{'date'});

		$tmp1 = $index;
		&Bforum::do($tmp1);
		&Bforum::change($tmp1,\%index);

		$tmp2 .= $tmp1;

	}

	return $head . $tmp2 . $foot;

}

##
## thread
## ΰɽ
sub thread {

	my ($head) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.thread.head");
	my ($foot) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.thread.foot");
	my ($thread) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.thread");

	my ($tmp1,$tmp2,$tmp3);

	while (1) {

		$tmp3++;

		undef %thread;
		&Bforum::_analysis(\%thread,"$SET{'USER_DIR'}/$in{'admin_id'}/$in{'admin_t'}/$tmp3");
		&Bforum::_time($thread{'date'});

		if (!$thread{'no'}) {
			last;
		}

		$thread{'admin_m'} = $tmp3;

		$tmp1 = $thread;
		&Bforum::do($tmp1);
		&Bforum::change($tmp1,\%thread);

		$tmp2 .= $tmp1;

	}

	return $head . $tmp2 . $foot;

}

##
## message
## ԽԤ

sub message {

	if ($in{'no'}) {

		my ($tmp1,$tmp2);

		foreach (sort keys %in) {

			if ($_ =~ /^(f|id|message|t|v|cc|plugin|passwd)$/) { next; }
			if ($_ =~ /^(password|action|admin_id|admin_t|admin_m)$/) { next; }

			my ($tmp1);
			$tmp1 = lc ($_);
			$tmp1 = ucfirst ($tmp1);
			$tmp2 .= "$tmp1: $in{$_}\n";

		}
		$tmp2 .= "\n$in{'message'}\n";

		if(&Bforum::_lock) {

			local ($Bforum::write);

			&Bforum::_write("$SET{'USER_DIR'}/$in{'admin_id'}/$in{'admin_t'}/$in{'admin_m'}",$tmp2);

			&Bforum::setting(\%SET,"$SET{'USER_DIR'}/$in{'admin_id'}/$Bforum::RCFILE");

			local ($Bforum::in{'id'}) = $in{'admin_id'};
			local ($Bforum::in{'t'}) = $in{'admin_t'};
			local (%Bforum::SET) = %SET;

			&Bforum::_diskwrite;

		}

		return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.message.complete");

	} else {

		my ($head) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.message.head");
		my ($foot) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.message.foot");
		my ($message) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.message.form");

		my ($tmp1,$tmp2);

		&Bforum::_analysis(\%message,"$SET{'USER_DIR'}/$in{'admin_id'}/$in{'admin_t'}/$in{'admin_m'}");
		$message{'message_date'} = $message{'date'};
		&Bforum::_time($message{'message_date'});

		&Bforum::do($head);
		&Bforum::change($head,\%message);

		for (keys %message) {

			if ($_ =~ /^(message_date)$/) { next; }

			$message{'name'} = $_;
			$Bforum::in{$_} = $message{$_};

			if ($_ =~ /^(agent|message|no|title|files|host|referer|full_title|address|author|version|email|date|delete)$/) { next; }

			$tmp1 = $message;
			&Bforum::do($tmp1);
			&Bforum::change($tmp1,\%message);

			$tmp2 .= $tmp1;

		}

		$Bforum::in{'message'} =~ s/<br \/>\n//go;

		return $head . $tmp2 . $foot;

	}

}

##
## action
## ɽ
sub action {

	if ($in{'admin_id'} && $in{'admin_t'}) {

		return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.thread.action");

	} elsif ($in{'admin_id'}) {

		return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.index.action");

	} else {

		return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.forums.action");

	}

}

##
## config
## 
sub config {

	if ($in{'admin_id'}) {

		## ե
		if ($in{'config'}) {
			&Bforum::_write("$SET{'USER_DIR'}/$in{'admin_id'}/$Bforum::RCFILE",$in{'config'});
			return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.config.complete");
		} else {
			$Bforum::in{'config'} = &Bforum::_open(undef,"$SET{'USER_DIR'}/$in{'admin_id'}/$Bforum::RCFILE");
			return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.config.form");
		}

	} else {

		## Τ
		if ($in{'config'}) {
			&Bforum::_write($Bforum::RCFILE,$in{'config'});
			return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.config.complete");
		} else {
			$Bforum::in{'config'} = &Bforum::_open(undef,$Bforum::RCFILE);
			return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.config.form");
		}

	}

}

##
## delete
## 
sub delete {

	my ($tmp1,$tmp2);
	my (@tmp3);

	if ($in{'confirm'}) {

		if ($in{'admin_id'}) {

			if ($in{'admin_t'}) {

				## åɤκ
				&rmdir("$SET{'USER_DIR'}/$in{'admin_id'}/$in{'admin_t'}");
				if (-f "$SET{'USER_DIR'}/$in{'admin_id'}/$in{'admin_t'}.bfa") {
					unlink ("$SET{'USER_DIR'}/$in{'admin_id'}/$in{'admin_t'}.bfa");
				}

				$tmp1 = 0;
				while (1) {

					if (-f "$SET{'USER_DIR'}/$in{'admin_id'}/$in{'admin_t'}.$tmp1.bfa") {
						unlink ("$SET{'USER_DIR'}/$in{'admin_id'}/$in{'admin_t'}.$tmp1.bfa");
					} else {
						last;
					}

					$tmp1++;

				}

				@tmp3 = &Bforum::_open('file',"$SET{'USER_DIR'}/$in{'admin_id'}/index");

				foreach (@tmp3) {
					chomp ($_);
					if ($_ eq $in{'admin_t'}) {
						undef $_;
					} else {
						$_ .= "\n";
					}
				}

				&Bforum::_write("$SET{'USER_DIR'}/$in{'admin_id'}/index",@tmp3);

				$tmp2 = &Bforum::_open(0,"$SET{'USER_DIR'}/$in{'admin_id'}/index");
				chomp($tmp2);

				&Bforum::_write("$SET{'USER_DIR'}/$in{'admin_id'}/last",&Bforum::_open(undef,"$SET{'USER_DIR'}/$in{'admin_id'}/$tmp2/" . (&Bforum::_open("line","$SET{'USER_DIR'}/$in{'admin_id'}/$tmp2/list") + 1)));

				local ($Bforum::in{'id'}) = $in{'admin_id'};
				local ($Bforum::in{'t'}) = $in{'admin_t'};
				&Bforum::status;

				return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.delete.complete");

			} else {

				## եκ
				&rmdir("$SET{'USER_DIR'}/$in{'admin_id'}/files");

				foreach (&Bforum::_open("file","$SET{'USER_DIR'}/$in{'admin_id'}/index")) {
					chomp($_);

					$tmp1 = 0;
					while (1) {

						if (-f "$SET{'USER_DIR'}/$in{'admin_id'}/$_.$tmp1.bfa") {
							unlink ("$SET{'USER_DIR'}/$in{'admin_id'}/$_.$tmp1.bfa");
						} else {
							last;
						}

						$tmp1++;

					}

					unlink ("$SET{'USER_DIR'}/$in{'admin_id'}/$_.bfa");
					&rmdir("$SET{'USER_DIR'}/$in{'admin_id'}/$_");

				}

				opendir(DIR,"$SET{'USER_DIR'}/$in{'admin_id'}");
				foreach (readdir(DIR)) {
					if ($_ =~ /^BF\./) {
						unlink("$SET{'USER_DIR'}/$in{'admin_id'}/$_");
					}
				}
				closedir(DIR);

				unlink("$SET{'USER_DIR'}/$in{'admin_id'}/.bforumrc");
				unlink("$SET{'USER_DIR'}/$in{'admin_id'}/.default");
				unlink("$SET{'USER_DIR'}/$in{'admin_id'}/index");
				unlink("$SET{'USER_DIR'}/$in{'admin_id'}/index.posts");
				unlink("$SET{'USER_DIR'}/$in{'admin_id'}/index.create");
				unlink("$SET{'USER_DIR'}/$in{'admin_id'}/last");
				unlink("$SET{'USER_DIR'}/$in{'admin_id'}/status");
				rmdir("$SET{'USER_DIR'}/$in{'admin_id'}");

				return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.delete.complete");

			}

		}

	} else {

		return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.confirm");

	}

}

##
## create
## ե
sub create {

	my ($tmp1);

	if ($in{'admin_id'} && !&Bforum::_open(undef,"$SET{'USER_DIR'}/$in{'admin_id'}/index")) {

		$Bforum::in{'admin_id'} = $in{'admin_id'};

		&Bforum::_write("$SET{'USER_DIR'}/$in{'admin_id'}/index");

		return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.create.complete");

	} else {

		return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.create.form");

	}

}

##
## plugin
## ץ饰ΰɽ
sub plugin {

	my ($head) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.plugin.head");
	my ($foot) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.plugin.foot");
	my ($plugin) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.plugin");

	my ($tmp1,$tmp2,$tmp3,$tmp4);
	my (@tmp5);
	my (%SET) = %SET;

	if ($in{'admin_id'}) {
		&Bforum::setting(\%SET,"$SET{'USER_DIR'}/$in{'admin_id'}/$Bforum::RCFILE");
	} else {
		&Bforum::setting(\%SET,$Bforum::RCFILE);
	}

	opendir (DIR,$SET{'PLUGIN_DIR'});
	@tmp5 = readdir (DIR);
	closedir (DIR);
	foreach (sort @tmp5) {

		if ($_ =~ /^(.+)\.pm$/) {

			$tmp1 = $1;

			if (eval("require \"$SET{'PLUGIN_DIR'}/$_\"") && ($tmp2 = eval("Bforum::Plugin::$tmp1->new();"))) {

				$plugin{'file'} = $tmp1;
				$plugin{'name'} = $tmp2->version();
				$plugin{'require'} = eval("join(\",\",\@Bforum::Plugin::${tmp1}::REQUIRE)");

				$tmp3 = $plugin;

				&Bforum::do($tmp3);
				&Bforum::change($tmp3,\%plugin);

				$tmp4 .= $tmp3;

			}

		}

	}

	if ($tmp4) {

		return $head . $tmp4 . $foot;

	} else {

		return;

	}

}

##
## design
## ǥΰ
sub design {

	my ($head) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.design.head");
	my ($foot) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.design.foot");
	my ($design) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.design");

	my ($tmp1,$tmp2);
	my (@tmp3);

	if ($in{'admin_id'}) {
		opendir(DIR,"$SET{'USER_DIR'}/$in{'admin_id'}");
		@tmp3 = readdir(DIR);
		closedir(DIR);
	} else {
		opendir(DIR,$SET{'USER_DIR'});
		@tmp3 = readdir(DIR);
		closedir(DIR);
	}

	foreach (sort @tmp3) {

		if ($_ =~ /^BF\./) {

			$design{'name'} = $_;

			$tmp1 = $design;

			&Bforum::do($tmp1);
			&Bforum::change($tmp1,\%design);

			$tmp2 .= $tmp1;

		}

	}

	return $head . $tmp2 . $foot;

}

##
## designshow
sub designshow {

	my ($tmp1,$tmp2);

	if ($in{'admin_id'}) {
		$tmp1 = &Bforum::_open(undef,"$SET{'USER_DIR'}/$in{'admin_id'}/$in{'file'}");
	} else {
		$tmp1 = &Bforum::_open(undef,"$SET{'USER_DIR'}/$in{'file'}");
	}

	$tmp2 = select (STDOUT);
	binmode (STDOUT);
	print "Content-type: application/octet-stream\n";
	print "Content-Disposition: attachment; filename=\"$in{'file'}\"\n";
	print "\n";
	print $tmp1;
	select ($tmp2);
	&Bforum::_exit(0);

}

##
## designdelete
sub designdelete {

	if ($in{'confirm'}) {

		if ($in{'admin_id'}) {
			unlink("$SET{'USER_DIR'}/$in{'admin_id'}/$in{'file'}");
		} else {
			unlink("$SET{'USER_DIR'}/$in{'file'}");
		}

		return &design . &forums;

	} else {

		return &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.confirm");

	}

}

##
## designdelete
sub designupload {

	my ($tmp1);

	$tmp1 = $in{'upload'};
	warn($tmp1);
	$tmp1 =~ s/^.*[\\\/\:]([^\\\/\:]+)$/$1/go;
	warn($tmp1);

	if ($in{'admin_id'}) {
		&Bforum::_write("$SET{'USER_DIR'}/$in{'admin_id'}/$tmp1",(split(/\n{2}/,$Bforum::files{'upload'},2))[1]);
	} else {
		&Bforum::_write("$SET{'USER_DIR'}/$tmp1",(split(/\n{2}/,$Bforum::files{'upload'},2))[1]);
	}
	&Bforum::_diskwrite;

	return &design . &forums;

}

##
## print
sub print {

	my ($head) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.head");
	my ($foot) = &Bforum::_open(undef,"$SET{'USER_DIR'}/BF.plugin.admin.foot");

	my (%print);

	$print{'host'} = $ENV{'REMOTE_HOST'};
	$print{'addr'} = $ENV{'REMOTE_ADDR'};
	if ($print{'host'} eq $print{'addr'} || $print{'host'} eq "") { $print{'host'} = gethostbyaddr(pack("C4",split(/\./,$print{'addr'})),2) || $print{'addr'}; }

	&Bforum::do($head);
	&Bforum::change($head,\%print);
	&Bforum::do($foot);
	&Bforum::change($foot,\%print);

	return $head . $_[0] . $foot;

}

##
## rmdir
## ǥ쥯ȥ
sub rmdir {

	my (@tmp1);

	if (-d $_[0]) {
		opendir (DIR,$_[0]);
		@tmp1 = readdir (DIR);
		closedir (DIR);
		foreach (@tmp1) {
			if ($_ =~ /^\.\.?$/) { next; }
			if (-d "$_[0]/$_") {
				&rmdir("$_[0]/$_");
			} else {
				unlink("$_[0]/$_");
			}
		}
		rmdir($_[0]);
	}

}

##
## vars
## ѿ򥻥åȤ
sub vars {

	%in = %{$_[0]};
	%SET = %{$_[1]};

}



1;


