# NOTE: Derived from ./src/Bforum.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Bforum;

#line 3026 "./src/Bforum.pm (autosplit into auto\Bforum\_time.al)"
##
## TIME Ver1.00
##
sub _time {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);
	my (@tmp2);

	$ENV{'TZ'} = $TEXT{'TIME_ZONE'} || "JST-9";
	@tmp2 = localtime($_[0]);
	$tmp1 = $_[1] || $TEXT{'TIME_FORMAT'};
	$tmp1 =~ s/%ss/sprintf("%02d",$tmp2[0])/ego;
	$tmp1 =~ s/%s/$tmp2[0]/go;
	$tmp1 =~ s/%mm/sprintf("%02d",$tmp2[1])/ego;
	$tmp1 =~ s/%m/$tmp2[1]/go;
	$tmp1 =~ s/%HH/{ if (($tmp2[2] - 12) > 0) { sprintf("%02d",($tmp2[2] - 12)); } else { sprintf("%02d",$tmp2[2]); } }/ego;
	$tmp1 =~ s/%H/{ if (($tmp2[2] - 12) > 0) { ($tmp2[2] - 12); } else { $tmp2[2]; } }/ego;
	$tmp1 =~ s/%hh/sprintf("%02d",$tmp2[2])/ego;
	$tmp1 =~ s/%h/$tmp2[2]/go;
	$tmp1 =~ s/%AP/(split(',',$TEXT{'AP_FORMAT'}))[(($tmp2[2] - 12) > 0)]/ego;
	$tmp1 =~ s/%DD/sprintf("%02d",$tmp2[3])/ego;
	$tmp1 =~ s/%D/$tmp2[3]/go;
	$tmp1 =~ s/%MF/(split(',',$TEXT{'MONTH_FORMAT'}))[($tmp2[4])]/ego;
	$tmp1 =~ s/%MM/sprintf("%02d",($tmp2[4] + 1))/ego;
	$tmp1 =~ s/%M/{$tmp2[4] + 1}/ego;
	$tmp1 =~ s/%YYYY/sprintf("%04d",($tmp2[5] + 1900))/ego;
	$tmp1 =~ s/%YY/sprintf("%02d",substr($tmp2[5],-1,2))/ego;
	$tmp1 =~ s/%w/(split(',',$TEXT{'WEEK_FORMAT'}))[($tmp2[6])]/ego;

	if (defined wantarray) {
		return $tmp1;
	} else {
		$_[0] = $tmp1;
		return $tmp1;
	}

}

# end of Bforum::_time
1;
