# NOTE: Derived from ./src/Bforum.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Bforum;

#line 3952 "./src/Bforum.pm (autosplit into auto\Bforum\check.al)"
##
## Check Ver1.01
##
sub check {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);

	## ADDRESS
	$check->{'Address'}->{'status'} = "OK";
	$check->{'Address'}->{'value'} = $SET{'ADDRESS'};
	if ($SET{'ADDRESS'} !~ /^.+\@.+\..+$/) {
		$check->{'Address'}->{'status'} = "NG";
	}

	## USER_DIR
	$check->{'User directory'}->{'status'} = "OK";
	$check->{'User directory'}->{'value'} = &_path("$SET{'USER_DIR'}/");
	if (!-d $SET{'USER_DIR'}) {
		$check->{'User directory'}->{'status'} = "NG";
		$check->{'User directory'}->{'value'} = "Not found:<strong>" . &_path($SET{'USER_DIR'}) . "</strong>";
	} elsif (!-r $SET{'USER_DIR'} || !-w $SET{'USER_DIR'} || !-x $SET{'USER_DIR'}) {
		$check->{'User directory'}->{'status'} = "NG";
		$check->{'User durectory'}->{'value'} = "Permission denied:<strong>" . &_path($SET{'USER_DIR'}) . "</strong>";
	}

	## 
	if ($in{'id'} ne 'Check') {

		## ȥǥ쥯ȥ
		$check->{'Data directory'}->{'status'} = "OK";
		$check->{'Data directory'}->{'value'} = &_path("$SET{'USER_DIR'}/$in{'id'}/");
		if (!-d "$SET{'USER_DIR'}/$in{'id'}") {
			$check->{'Data directory'}->{'status'} = "NG";
			$check->{'Data directory'}->{'value'} = "Not found:<strong>" . &_path("$SET{'USER_DIR'}/$in{'id'}") . "</strong>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}" || !-w "$SET{'USER_DIR'}/$in{'id'}" || !-x "$SET{'USER_DIR'}/$in{'id'}") {
			$check->{'Data directory'}->{'status'} = "NG";
			$check->{'Data directory'}->{'value'} = "Permission denied:<strong>" . &_path("$SET{'USER_DIR'}/$in{'id'}") . "</strong>";
		}

		## indexեγǧ
		$check->{'Index file'}->{'status'} = "OK";
		$check->{'Index file'}->{'value'} = &_path("$SET{'USER_DIR'}/$in{'id'}/index");
		if (!-d "$SET{'USER_DIR'}/$in{'id'}") {
			$check->{'Index file'}->{'status'} = "NG";
			$check->{'Index file'}->{'value'} = "Not found:<strong>" . &_path("$SET{'USER_DIR'}/$in{'id'}/index") . "</strong>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}/index" || !-w "$SET{'USER_DIR'}/$in{'id'}/index") {
			$check->{'Index file'}->{'status'} = "NG";
			$check->{'Index file'}->{'value'} = "Permission denied:<strong>" . &_path("$SET{'USER_DIR'}/$in{'id'}/index") . "</strong>";
		}

	}

	## Sendmail
	$check->{'Sendmail'}->{'status'} = "OK";
	($tmp1,undef) = split(/\s/,$SET{'SENDMAIL'});
	$check->{'Sendmail'}->{'value'} = $SET{'SENDMAIL'};
	if (!-e $tmp1) {
		$check->{'Sendmail'}->{'status'} = "NG";
		$check->{'Sendmail'}->{'value'} = "Not found:<b>$tmp1</b>";
	} elsif (!-x $tmp1 && !-r $tmp1) {
		$check->{'Sendmail'}->{'status'} = "NG";
		$check->{'Sendmail'}->{'value'} = "Permission denied:<b>$tmp1</b>";
	}

	foreach (
		{item => "Do sendmail",set => "SENDMAIL_DO"},
		{item => "Do portal",set => "PORTAL_DO"},
		{item => "Do check",set => "CHECK_DO"},
		{item => "Do archive",set => "ARCHIVE_DO"},
		{item => "Do compress",set => "COMPRESS_DO"},
		{item => "Do cache",set => "CACHE_DO"},
		{item => "Do fileupload",set => "FILE_UPLOAD_DO"},
	) {
		$check->{$_->{'item'}}->{'status'} = "Yes";
		$check->{$_->{'item'}}->{'value'} = "Value OK";
		if ($SET{$_->{'set'}} eq 'N') {
			$check->{$_->{'item'}}->{'status'} = "No";
		} elsif ($SET{$_->{'set'}} ne 'Y') {
			$check->{$_->{'item'}}->{'value'} = "Illegal value:<b>$SET{$$_{'set'}}</b>";
		}
	}

	$check->{'User name'}->{'status'} = "OK";
	$check->{'User name'}->{'value'} = getlogin;

	$check->{'Default Language'}->{'status'} = "OK";
	$check->{'Default Language'}->{'value'} = $SET{'LANGUAGE'};

	## BF.*եγǧ
	foreach ("BF.about","BF.browser","BF.confirm","BF.delete","BF.email","BF.email.error","BF.foot","BF.form","BF.help","BF.head","BF.index","BF.index.foot","BF.index.head","BF.list","BF.list.foot","BF.list.head","BF.notice","BF.portal","BF.regist","BF.thread","BF.thread.foot","BF.thread.head","BF.tree","BF.tree.foot","BF.tree.head","BF.message") {
		$check->{$_}->{'status'} = "OK";
		if (!-f "$SET{'USER_DIR'}/$in{'id'}/$_" && !-f "$SET{'USER_DIR'}/$_" && !-f "$SET{'USER_DIR'}/$in{'id'}/BF.bfa" && !-f "$SET{'USER_DIR'}/BF.bfa") {
			## ե뤬̵
			$check->{$_}->{'status'} = "NG";
			$check->{$_}->{'value'} = "Not found<b>$_</b>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}/$_" && !-r "$SET{'USER_DIR'}/$_" && !-r "$SET{'USER_DIR'}/$in{'id'}/BF.bfa" && !-r "$SET{'USER_DIR'}/BF.bfa") {
			## ѡߥå󤬴ְäƤ
			$check->{$_}->{'status'} = "NG";
			$check->{$_}->{'value'} = "Permission denied:<b>$_</b>";
		} else {
			if (-f "$SET{'USER_DIR'}/$in{'id'}/$_" && -r "$SET{'USER_DIR'}/$in{'id'}/$_") {
				## ե(ȥե/BF.*)
				$check->{$_}->{'value'} = &_path("$SET{'USER_DIR'}/$in{'id'}/$_");
			} elsif (-f "$SET{'USER_DIR'}/$_" && -r "$SET{'USER_DIR'}/$_") {
				## ե(Хե/BF.*)
				$check->{$_}->{'value'} = &_path("$SET{'USER_DIR'}/$_");
			} elsif (&_open('line',"$SET{'USER_DIR'}/$in{'id'}/$_")) {
				## ե(ȥե/BF.bfa)
				$check->{$_}->{'value'} = &_path("$SET{'USER_DIR'}/$in{'id'}/BF.bfa");
			} elsif (&_open('line',"$SET{'USER_DIR'}/$_")) {
				## ե(Хե/BF.*)
				$check->{$_}->{'value'} = &_path("$SET{'USER_DIR'}/BF.bfa");
			} else {
				## Ϥե뤬̵
				$check->{$_}->{'status'} = "NG";
				$check->{$_}->{'value'} = "Not found<b>$_</b>";
			}
		}
	}

	## jcode.plNKFγǧ
	$check->{'Code filter'}->{'status'} = "OK";
	if ($init{'code'}) {
		if ($SET{'NKF'}) {
			$check->{'Code filter'}->{'value'} = "$SET{'NKF'}";
		} elsif ($SET{'JCODE'}) {
			$check->{'Code filter'}->{'value'} = &_path($SET{'JCODE'});
		}
	} else {
		$check->{'Code filter'}->{'status'} = "NG";
	}

	$tmp2 = 0;
	foreach (sort keys %{$check}) {
		$check->{$_}->{'value'} ||= "&nbsp;";
		if ($check->{$_}->{'status'} eq 'NG') {
			$check->{$_}->{'status'} = "<b style=\"color:#ff0000\">NG</b>";
			$tmp2 ++;
		}
		$print .= "<tr>	<th>$_</th>	<th>$check->{$_}->{'status'}</th>	<td>$check->{$_}->{'value'}</td>	</tr>\n";
	}
	$print = "<b>$tmp2</b> of status are NG.\n<table border=\"1\">$print</table>\n";


	if (-f "$SET{'USER_DIR'}/$in{'id'}/index") { &status; }

	undef @_;

}

# end of Bforum::check
1;
