# NOTE: Derived from ./src/Bforum.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Bforum;

#line 663 "./src/Bforum.pm (autosplit into auto\Bforum\message.al)"
sub message {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if($in{'m'}) {
		$message = &_bfopen("BF.message");
	} else {
		$in{'m'} = 1;
		$message = &_bfopen("BF.thread.head");
	}

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);
	my (@tmp7,@tmp8);

	if (!defined &_indexcheck($in{'id'},$in{'t'})) { &about; }

	&_analysis(\%message,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$in{'m'}");

	if (!$message{'no'}) { &about; }

	$message{'number'} = $num + 1;

	$message{'new'} = "";
	if ($message{'date'} + $SET{'NEW_TIME'} > $time) {
		$message{'new'} = $TEXT{'NEW_ELEM'};
		$donot->{cache} = 1;
	}
	if ($message =~ /{date:(.+?)}/o) { $message{"date:$1"} = &_time($message{'date'},$1); }
	&_time($message{'date'});

	if ($message{'delete'} || !&_listcheck($in{'id'},$in{'t'},$in{'m'})) {
		$message{'title'} = $TEXT{'DELETE_PREFIX'} . $message{'title'};
		&_analysis(\%message,"$SET{'USER_DIR'}/$in{'id'}/BF.delete","$SET{'USER_DIR'}/BF.delete");
		$message{'email'} = $SET{'ADDRESS'};
	}

	if ($message =~ /{title\((.+?)\)}/o) { $message{"title($1)"} = &_cut($message{'full_title'},$1,'...'); }

	&tag($message{'message'});

	&_autolink($message{'message'});

	# HTML -> XHTML
	&_xhtmlcheck($message{'message'});

	$message{'message'} =~ s/(^|\n)(\s*((&gt;|)(&gt;||\s*)*)[^\n]*)/$1<span class="quotation">$2<\/span>/go;
	$message{'message'} =~ s/(^|\n)(\s*((#|)(#||\s*)*)[^\n]*)/$1<span class="comment">$2<\/span>/go;

	$tmp2 = int(($in{'m'} - 1) / $SET{'LIST_NUMBER'}) + 1;

	$tmp1 = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");
	if ($in{'m'} eq '1') {
		$tmp3 = int(($tmp1 - 1) / $SET{'TREE_NUMBER'}) + 1;
		$in{'s'} ||= 1;
	} else {
		foreach (0 .. $tmp1) {
			if ($in{'m'} eq (split(/<0>/,&_open($_,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[0]) {
				$tmp3 = int($_ / $SET{'TREE_NUMBER'}) + 1;
				last;
			}
		}
	}

	## Referer
	if ($message{'referer'}) {
		$message{'msg:referer:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&m=$message{'referer'}";
		$message{'msg:referer'} = $TEXT{'DISP_REFERER_PREFIX'} . &_link("id=$in{'id'}&t=$in{'t'}&m=$message{'referer'}",($TEXT{'DISP_REFERER_NUMBER_PREFIX'} . $message{'referer'} . $TEXT{'DISP_REFERER_NUMBER_SUFFIX'})) . $TEXT{'DISP_REFERER_SUFFIX'};
	}

	## Responce
	undef $tmp6;
	foreach (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")) {

		chomp($_);

		if ((split(/<0>/,$_))[0] eq $in{'m'}) {
			$tmp6 = (split(/<0>/,$_))[1];
			next;
		}

		if (defined $tmp6 && (split(/<0>/,$_))[1] <= $tmp6) {
			last;
		}

		if (defined $tmp6 && (split(/<0>/,$_))[1] == ($tmp6 + 1)) {
			push (@tmp7,(split(/<0>/,$_))[0]);
		}

	}

	if (@tmp7) {
		$message{'msg:response'} = $TEXT{'DISP_RESPONSE_PREFIX'} . join($TEXT{'DISP_RESPONSE_BAR'},map { &_link("id=$in{'id'}&t=$in{'t'}&m=$_",($TEXT{'DISP_RESPONSE_NUMBER_PREFIX'} . $_ . $TEXT{'DISP_RESPONSE_NUMBER_SUFFIX'})) } @tmp7) . $TEXT{'DISP_RESPONSE_SUFFIX'};
	}

	## Files
	foreach (split(/,/,$message{'files'})) {
		push (@tmp8,$_);
	}
	if (@tmp8) {
		$message{'msg:files'} = $TEXT{'DISP_FILES_PREFIX'} . join($TEXT{'DISP_FILES_BAR'},map { &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&d=$_",($TEXT{'DISP_FILES_NUMBER_PREFIX'} . $_ . $TEXT{'DISP_FILES_NUMBER_SUFFIX'})) } @tmp8) . $TEXT{'DISP_FILES_SUFFIX'};
	}

	&_analysis(\%thread,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1");
	foreach (keys %thread) {
		$message{$_ . ":thread"} = $thread{$_};
	}

	$tmp4 = $message;

	&do($tmp4);
	&change($tmp4,\%message);

	if ($in{'m'} <= 1) {
		$print{'back'} = $TEXT{'DISP_BACK_NL'};
	} else {
		$tmp5 = $in{'m'} - 1;
		$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$tmp5",$TEXT{'DISP_BACK'});
	}

	if ($in{'m'} >= $message{'number'}) {
		$print{'next'} = $TEXT{'DISP_NEXT_NL'};
	} else {
		$tmp5 = $in{'m'} + 1;
		$print{'next'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$tmp5",$TEXT{'DISP_NEXT'});
	}

	if (!$_[0] && $message{'number'} ne '1') {
		$print{'tree'} = &_link("id=$in{'id'}&t=$in{'t'}&m=tree&s=$tmp3",$TEXT{'DISP_TREE'});
	} else {
		$print{'tree'} = $TEXT{'DISP_TREE_NL'};
	}
	$print{'list:url'} = "id=$in{'id'}&t=$in{'t'}&m=list&s=$tmp2";
	$print{'tree:url'} = "id=$in{'id'}&t=$in{'t'}&m=tree&s=$tmp3";
	$print{'list'} = &_link("id=$in{'id'}&t=$in{'t'}&m=list&s=$tmp2",$TEXT{'DISP_LIST'});

	&change($tmp4,\%print);
	undef %print;

	$print .= $tmp4;

}

# end of Bforum::message
1;
