# NOTE: Derived from ./src/Bforum.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Bforum;

#line 1107 "./src/Bforum.pm (autosplit into auto\Bforum\search.al)"
sub search {

	local($altitude) = $altitude + 1;

	&_logging(7);

	$head = &_bfopen("BF.search.head");
	$foot = &_bfopen("BF.search.foot");
	$search = &_bfopen("BF.search");

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);
	my (@tmp7);

	if ($SET{'NAMAZU'}) {

		## Search Namazu

		if (defined $in{'s'} && $in{'s'} < 1) { &about; }
		$in{'s'} ||= 1;

		## Not CGI
		$tmp2 = $ENV{'SCRIPT_NAME'};
		delete $ENV{'SCRIPT_NAME'};

		@tmp7 = ($SET{'NAMAZU'},"--list","--sort=\"$in{'search.sort'}\"","--config=\"$SET{'NAMAZU_CONFIG'}\"");

		if ($in{'search.order'} eq "ascending") {
			push(@tmp7,"--ascending");
		}

		push(@tmp7,$in{'search.query'});

		if (ref $in{'search.idxname'}) {
			foreach (@{$in{'search.idxname'}}) {
				push(@tmp7,"$SET{'NAMAZU_INDEX'}/$_");
			}
		} elsif ($in{'search.idxname'}) {
			push(@tmp7,"$SET{'NAMAZU_INDEX'}/$in{'search.idxname'}");
		} else{
			push(@tmp7,$SET{'NAMAZU_INDEX'});
		}

		open (NAMAZU,"@tmp7 |");
		binmode (NAMAZU);
		undef $line;
		foreach (<NAMAZU>) {

			if ($_ =~ /id=(.*?)&t=(.*?)&m=([^\n\r\&]*)/) {

				my (%in) = %in;

				$in{'id'} = $1;
				$in{'t'} = $2;
				$in{'m'} = $3;

				undef %search;

				if (&_analysis(\%search,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$in{'m'}")) {

					$line++;

					if ($line > (($in{'s'} - 1) * $SET{'SEARCH_NUMBER'}) && $line <= ($in{'s'} * $SET{'SEARCH_NUMBER'})) {

						$search{'new'} = "";
						if ($search{'date'} + $SET{'NEW_TIME'} > $time) {
							$search{'new'} = $TEXT{'NEW_ELEM'};
							$donot->{cache} = 1;
						}
						if ($search =~ /{date:(.+?)}/o) { $search{"date:$1"} = &_time($search{'date'},$1); }
						&_time($search{'date'});
						if ($search{'delete'} || !&_listcheck($in{'id'},$in{'t'},$in{'m'})) {
							$search{'title'} = $TEXT{'DELETE_PREFIX'} . $search{'title'};
							&_analysis(\%search,"$SET{'USER_DIR'}/$in{'id'}/BF.delete","$SET{'USER_DIR'}/BF.delete");
							$search{'email'} = $SET{'ADDRESS'};
						}
						if ($search =~ /{title:(.+?)}/o && $1 =~ /^\d*$/o) { $search{"title:$1"} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}",&_cut($search{'full_title'},$1,'...')); }
						$search{'title:nl'} = $search{'full_title'};
						$search{'title'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}",$search{'title'});

						&_analysis(\%thread,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1");
						foreach (keys %thread) {
							$search{$_ . ":thread"} = $thread{$_};
						}

						$tmp3 = $search;
						&do($tmp3);
						&change($tmp3,\%search);

						$tmp1 .= $tmp3;

					}

				}

			}


		}

		close (NAMAZU);

		$ENV{'SCRIPT_NAME'} = $tmp2;

		if ($line) {

			$hit = $line;

			if ((($in{'s'} - 1) * $SET{'SEARCH_NUMBER'}) >= $line) { &about; }

			if ($in{'s'} < 2) {
				$print{'back'} = $TEXT{'DISP_SEARCH_BACK_NL'};
			} else {
				if ($in{'s'} == 1) {
					$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&f=$in{'f'}&cc=$in{'cc'}&search.query=$in{'search.query'}&search=$in{'search'}&search.sort=$in{'search.sort'}&search.order=$in{'search.order'}&s=",$TEXT{'DISP_SEARCH_BACK'});
				} else {
					$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&f=$in{'f'}&cc=$in{'cc'}&search.query=$in{'search.query'}&search=$in{'search'}&search.sort=$in{'search.sort'}&search.order=$in{'search.order'}&s=" . ($in{'s'} - 1),$TEXT{'DISP_SEARCH_BACK'});
				}
			}
			if (($in{'s'} * $SET{'SEARCH_NUMBER'}) >= $line) {
				$print{'next'} = $TEXT{'DISP_SEARCH_NEXT_NL'};
			} else {
				$print{'next'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&f=$in{'f'}&cc=$in{'cc'}&search.query=$in{'search.query'}&search=$in{'search'}&search.sort=$in{'search.sort'}&search.order=$in{'search.order'}&s=" . ($in{'s'} + 1),$TEXT{'DISP_SEARCH_NEXT'});
			}

			## 硼ȥå
			$print{'page'} = $TEXT{'DISP_SEARCH_PAGE_BEGIN'};
			## Nextɬ
			$tmp4 = int(($line - (1 % $SET{'SEARCH_NUMBER'})) / $SET{'SEARCH_NUMBER'}) + 1;

			undef $tmp5;
			foreach (1 .. $tmp4) {

				if (!$SET{'SEARCH_PAGE_SHOW'} || abs($_ - $in{'s'}) < ($SET{'SEARCH_PAGE_SHOW'} / 2) || abs($_ - 1) < $SET{'SEARCH_PAGE_SHOW'} || abs($_ - $tmp4) < $SET{'SEARCH_PAGE_SHOW'}) {

					if ($_ == $in{'s'}) {
						$print{'page'} .= $_;
					} else {
						$print{'page'} .= &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&f=$in{'f'}&cc=$in{'cc'}&search.query=$in{'search.query'}&search=$in{'search'}&search.sort=$in{'search.sort'}&search.order=$in{'search.order'}&s=" . $_,$_);
					}

					if ($tmp4 ne $_) {
						## ǸǤϤʤ
						$print{'page'} .= $TEXT{'DISP_SEARCH_PAGE_BAR'};
					}

					$tmp5 = 1;

				} elsif ($tmp5) {

						$print{'page'} .= $TEXT{'DISP_SEARCH_PAGE_NULL'};
						undef $tmp5;

				}

			}
			$print{'page'} .= $TEXT{'DISP_SEARCH_PAGE_END'};

		}

		if ($tmp1) {

			$tmp6 = $head . $tmp1 . $foot;
			&change($tmp6,\%print);
			undef %print;

			$print .= $tmp6;

		} else {

			$print .= &_bfopen("BF.search.notfound") || $TEXT{'ERROR_MSG_SEARCH_NOTFOUND'};

		}

	} else {

		## Cannot search
		$print .= $TEXT{'ERROR_MSG_CANNOT_SEARCH'};

	}

}

# end of Bforum::search
1;
