#==========================================================================#
#  B.Forum                                                               #
#  RSSץ饰 Ver.1.02                                                #
#  Encode = EUC                                                          #
#  Sakuma,Hiroaki ( sakuma@beetas.org )                                  #
#  BEETAS.org ( info@beetas.org )                                        #
#                                                                          #
# Υץꥱϥץ󥽡Ǥ.                          #
# ̵ǻѤ뤳ȤǤޤ.                                            #
# ʤ, ܺ٤ʻѾ/ǿˤĤƤϲȤ.           #
# http://www.beetas.org/                                                   #
#                                                                          #
# ------------------------------------------------------------------------ #
# Copyright 2002-2004 Sakuma,Hiroaki All Rights Reserved.                  #
# Copyright 2002-2004 BEETAS.org All Rights Reserved.                      #
#                                                                          #
#==========================================================================#
package Bforum::Plugin::rss;

$VERSION = "1.02";
@REQUIRE = ("1.02B-1");
@METHOD = ("rss","index","browser","print");

use strict;
use vars qw($VERSION @REQUIRE @METHOD);

my (%in,%SET,%TEXT);


## ᥽å

## new
## 󥹥󥹤֤
## $obj = Bforum::Plugin::edit->new(
##    in => \%in,
##    SET => \%SET,
## );
sub new {

	my ($tmp1) = shift;
	my ($class) = ref($tmp1) || $tmp1;
	my ($self) = {};
	my ($tmp3);

	$self->{'in'} = {};
	$self->{'SET'} = {};

	my (%tmp2) = @_;
	foreach (keys %tmp2) {
		$self->{$_} = $tmp2{$_};
	}

	%in = %{$self->{'in'}};
	%SET = %{$self->{'SET'}};

	if (ref $in{'plugin'}) {
		foreach (@{$in{'plugin'}}) {
			if ($_ eq "rss") {
				$tmp3 = 1;
			}
		}
	} elsif ($in{'plugin'} eq "rss") {
		$tmp3 = 1;
	}

	if ($tmp3) {

		bless ($self, $class);

		return $self;

	} else {

		return;

	}

}

## version
## С֤
## $obj->version();
sub version {

	my ($self) = shift;

	my ($version) = "BEETAS.org إåɥ饤ץ饰 $VERSION(" . join(",",@REQUIRE) . ")";
	return $version;

}

## require
## ưСΥå
## $obj->require($revision);
sub require {

	my ($self) = shift;
	my ($version,$revision) = @_;
	my ($tmp1) = 0;

	foreach (@REQUIRE) {
		if ($_ =~ /^($version|$revision)$/) {
			$tmp1 = 1;
			last;
		}
	}

	return $tmp1;

}

## args
## 餦
## $obj->args(
##   in => \%in,
##   SET => \%SET,
## );
sub args {

	my ($self) = shift;

	my (%args) = @_;
	foreach (keys %args) {
		$self->{$_} = $args{$_};
	}

	%in = %{$self->{'in'}};
	%SET = %{$self->{'SET'}};
	%TEXT = %{$self->{'TEXT'}};

}



sub rss {

	$Bforum::browser->{'browser'} = ".rss";
	$Bforum::browser->{'content'} = "application/xml";
#	$Bforum::browser->{'code'} = "UTF-8,";
	if ($in{'line'}) { $Bforum::SET{'INDEX_NUMBER'} = $in{'line'}; }

	return;

}

sub index {

	my ($self) = shift;

	$Bforum::browser->{'browser'} = ".rss.channel";
	&Bforum::index;

	$Bforum::browser->{'browser'} = ".rss.item";
	&Bforum::index;

	$Bforum::browser->{'browser'} = ".rss";

	return "";

}

sub browser {

	return "";

}

sub print {

	my ($print) = $Bforum::print;

	my ($tmp1,$tmp2);

	my ($head) = &Bforum::_bfopen("BF.head");
	my ($foot) = &Bforum::_bfopen("BF.foot");

	if (!$Bforum::donot->{head}) { $print = $head . $print . $foot; }
	&Bforum::_default;

	&Bforum::change($print,\%TEXT);

	&Bforum::_analysis(\%Bforum::status,"$SET{'USER_DIR'}/$in{'id'}/status");
	if (!($Bforum::status{'thread'} && $Bforum::status{'log'} && $Bforum::status{'date'}) && -f "$SET{'USER_DIR'}/$in{'id'}/index") { &Bforum::status; }
	if ($print =~ /{date:(.+?)}/o) { $Bforum::status{"date:$1"} = &Bforum::_time($Bforum::status{'date'},$1); }
	&Bforum::_time($Bforum::status{'date'});
	&Bforum::change($print,\%Bforum::status);

	&Bforum::do($print);
	&Bforum::change($print);
	$print =~ s/\\{/\{/go;
#	$print =~ s/([^\\])\\([^\\])/$1$2/go;
	$print =~ s/\\\\/\\/go;

	## Cross Site Scripting
	&Bforum::_xss($print);

	&Bforum::code(\$print,"euc");

	select (STDOUT);

	$Bforum::title = " $Bforum::title";
	## ȯ(B)
	$print =~ s/<title(.*?)>(.*?)<\/title>/<title$1>B.Forum : $2$Bforum::title - $Bforum::VERSION(Revision:$Bforum::REVISION)<\/title>/i;

	$Bforum::header .= "Content-Type: $Bforum::browser->{content}; charset=$Bforum::code[0]\n";
	$Bforum::header .= "Accept-Ranges: bytes\n";
	$Bforum::header .= "Last-Modified: " . &Bforum::_http_time($Bforum::time) . "\n";
	$print = $Bforum::header . "\n" . $print;

	if ($Bforum::donot->{body}) {

		print $Bforum::header . "\n";

	} elsif(!$Bforum::donot->{print}) {

		print $print;

	}

	&Bforum::_cache;

	return "";

}

1;

