# NOTE: Derived from ./src/Bforum.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Bforum;

#line 1528 "./src/Bforum.pm (autosplit into auto\Bforum\registprepare.al)"
sub registprepare {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7);

	foreach (split(/,/,$SET{'INDISPENSABLE'})) {
		if (!$in{$_} && !$in{"nocokkie.$_"}) {
			$tmp1 = 1;
			$notice .= "$TEXT{'ERROR_MSG_NO_ITEM'}\n";
			last;
		}
	}

	if (($in{'email'} && $in{'email'} !~ /\S+\@\S+\.\S+/) || ($in{'nocookie.email'} && $in{'nocokkie.email'} !~ /\S+\@\S+\.\S+/)) {
		$tmp1 = 1;
		$notice .= "$TEXT{'ERROR_MSG_WRONG_EMAIL'}\n";
	}

	if ($SET{'FILE_UPLOAD_DO'} ne 'N') {

		## Check filesize
		foreach (keys %files) {

			if ($SET{'FILE_UPLOAD_LIMIT_' . uc($_)}) {

				## Several
				if ($SET{'FILE_UPLOAD_LIMIT_' . uc($_)} < length((split(/\n{2}/,$files{$_}))[1])) {
					$tmp1 = 1;
					$notice .= "$TEXT{'ERROR_MSG_OVERFLOW_FILE_UPLOAD'}(" . length((split(/\n{2}/,$files{$_}))[1]) . ")\n";
				}

			} elsif ($SET{'FILE_UPLOAD_LIMIT'}) {

				## Common
				if ($SET{'FILE_UPLOAD_LIMIT'} < length((split(/\n{2}/,$files{$_}))[1])) {
					$tmp1 = 1;
					$notice .= "$TEXT{'ERROR_MSG_OVERFLOW_FILE_UPLOAD'}(" . length((split(/\n{2}/,$files{$_}))[1]) . ")\n";
				}

			}

		}

	} else {

		if (%files) {
			$tmp1 = 1;
			$notice .= "$TEXT{'ERROR_MSG_WRONG_FILE_UPLOAD'}\n";
		}

	}

	if ($SET{'FILE_UPLOAD_TYPECHECK_DO'} ne 'N') {

		## Check filetype
		if (!&_use("File::Type")) {

			$tmp2 = File::Type->new();

			foreach (keys %files) {

				if ($SET{('FILE_UPLOAD_TYPE_' . uc($_))}) {

					## Several
					undef $tmp6;
					foreach $tmp7 (split(/\s+/,$SET{'FILE_UPLOAD_TYPE_' . uc($_)})) {
						if ($tmp2->checktype_contents((split(/\n{2}/,$files{$_}))[1]) eq $tmp7) {
							$tmp6 = 1;
						}
					}

					if (!$tmp6) {
						$tmp1 = 1;
						$notice .= "$TEXT{'ERROR_MSG_IGNORETYPE_FILE_UPLOAD'}(" . $tmp2->checktype_contents((split(/\n{2}/,$files{$_}))[1]) . ")\n";
					}

				} elsif ($SET{'FILE_UPLOAD_TYPE'}) {

					## Common
					undef $tmp6;
					foreach $tmp7 (split(/\s+/,$SET{'FILE_UPLOAD_TYPE'})) {
						if ($tmp2->checktype_contents((split(/\n{2}/,$files{$_}))[1]) eq $tmp7) {
							$tmp6 = 1;
						}
					}

					if (!$tmp6) {
						$tmp1 = 1;
						$notice .= "$TEXT{'ERROR_MSG_IGNORETYPE_FILE_UPLOAD'}(" . $tmp2->checktype_contents((split(/\n{2}/,$files{$_}))[1]) . ")\n";
					}

				}

			}

		}

	}

	if ($tmp1) {
		$notice .= "$TEXT{'ERROR_MSG_CANNOT_WRITE'}\n";
		undef $in{'passwd'};
		&form;
		return;
	} else {

		if ($in{'confirm'}) {
			&confirm;
			return;
		}

		$in{'host'} = $ENV{'REMOTE_HOST'};
		$in{'addr'} = $ENV{'REMOTE_ADDR'};
		if ($in{'host'} eq $in{'addr'} || $in{'host'} eq "") { $in{'host'} = gethostbyaddr(pack("C4",split(/\./,$in{'addr'})),2) || $in{'addr'}; }

		foreach (sort keys %in) {

			if ($_ =~ s/nocokkie\.//o) {
				$in{$_} = $in{"nocookie.$_"};
				delete $in{"nocookie.$_"};
			}

			if ($_ =~ /^(f|id|message|t|m|cc|plugin|passwd)$/) { next; }

			my ($tmp3);
			$tmp3 = lc ($_);
			$tmp3 = ucfirst ($tmp3);
			$tmp4 .= "$tmp3: $in{$_}\n";

		}

		if (!$in{'t'}) {
			$no = 1;
		} else {
			$no = $num + 2;
		}

		&_analysis(\%check,"$SET{'USER_DIR'}/$in{'id'}/last");

		if ($in{'author'} eq $check{'author'} && $in{'title'} eq $check{'title'} && $in{'m'} eq $check{'referer'} && $in{'addr'} eq $check{'addr'} && $in{'host'} eq $check{'host'} && $ENV{'HTTP_USER_AGENT'} eq $check{'agent'}) {

			&do($regist);
			&change($regist,\%regist);

			$print{'jump'} = "$cgi?id=$in{'id'}&t=$in{'t'}&m=$check{'no'}";

			&change($regist,\%print);
			undef %print;

			$header .= &_set_cookie;
			$print .= $regist;

			$donot->{head} = 1;
			$donot->{cache} = 1;

			return;

		}

		foreach (keys %files) {
			$tmp5 = $_;
			$tmp5 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
			$in{'files'} .= "$tmp5, ";
		}


		$tmp4 .= "No: $no\n";
		$tmp4 .= "Agent: $ENV{'HTTP_USER_AGENT'}\n";
		$tmp4 .= "Version: $VERSION(Revision:$REVISION)\n";
		$tmp4 .= "Date: $time\n";
		$tmp4 .= "Files: $in{'files'}\n";
		$tmp4 .= "Referer: $in{'m'}\n";
		$tmp4 .= "\n$in{'message'}\n";

		if (&_lock) {
			return $tmp4;
		} else {
			&form;
			return;
		}

	}

}

# end of Bforum::registprepare
1;
