#==========================================================================#
#  B.Forum Ver.1.02                                                      #
#  ⥸塼                                                          #
#  Encode = EUC                                                          #
#  Sakuma,Hiroaki ( sakuma@beetas.org )                                  #
#  BEETAS.org ( info@beetas.org )                                        #
#                                                                          #
# Υץꥱϥץ󥽡Ǥ.                          #
# ̵ǻѤ뤳ȤǤޤ.                                            #
# ʤ, ܺ٤ʻѾ/ǿˤĤƤϲȤ.           #
# http://www.beetas.org/                                                   #
#                                                                          #
# ------------------------------------------------------------------------ #
# Copyright 2001-2004 Sakuma,Hiroaki All Rights Reserved.                  #
# Copyright 2001-2004 BEETAS.org All Rights Reserved.                      #
#                                                                          #
#==========================================================================#
package Bforum;

$VERSION = '1.02B-1';
$REVISION = '1.02.0065';
$RCFILE = '.bforumrc';
#$RCFILE = 'bforum.conf';


use AutoLoader('AUTOLOAD');


## ̩ʸˡå
use strict qw(vars subs);

require 5.005;

## Хѿ
use vars qw($print $altitude $cgi $uri $url $head $foot $num $no $line $hit $notice $host $addr $header $return $log $date $id $title);

## BF.*ե
use vars qw($portal $index $thread $message $list $tree $search $form $regist $plugin $time $confirm $check);

## ե
use vars qw($browser $do $donot $cache $error $write $d2s $s2d $logging $loglevel);

## ֥롼ϥå
use vars qw(%print %index %thread %message %download %list %tree %search %check %regist %doplugin %form %status %time %create %last %confirm %email);

## Хѿ
use vars qw($RCFILE $VERSION $REVISION);
use vars qw(@code @QUERY);
use vars qw(%init %in %files);
use vars qw(%SET %TEXT %WARNING);



__END__



sub main {

	&_logging(7,$ENV{'REMOTE_ADDR'});

	my ($tmp1);

	&init;

	if (defined &plugin(undef,@_)) {
		&_exit(0);
	}

	if ($QUERY[0] eq 'Check') {
		## Flush to cache
		&_cache_flush;
		$donot->{cache} = 1;
	}

	## Count
	if ($in{'id'} && $in{'t'} && defined &_indexcheck($in{'id'},$in{'t'})) {
		&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/count",&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/count") + 1);
	}

	## Caching
	$tmp1 = join('&',@QUERY);
	$tmp1 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
	if (-f ("$SET{'USER_DIR'}/.cache/$tmp1$browser->{'language'}$browser->{'browser'}")) {
		print &_open(undef,("$SET{'USER_DIR'}/.cache/$tmp1$browser->{'language'}$browser->{'browser'}"));
		&_exit(0);
	}

	if (!($in{'plugin'} && defined &plugin($in{'plugin'}))) {

		## Not extention plugin(default)
		if ($QUERY[0] eq 'Check' && $SET{'CHECK_DO'} ne 'N') {
			## Check
			&check;
		} elsif ($QUERY[0] eq 'Help') {
			## Help
			&help;
		} elsif (!$QUERY[0] && $SET{'PORTAL_DO'} ne 'N') {
			## Portal
			&portal;
		} elsif (defined $in{'search'}) {
			## Search
			&search;
		} elsif ($in{'t'}) {
			$num = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");
			if ($in{'m'}) {
				if ($in{'m'} eq 'list') {
					## List
					&list;
				} elsif ($in{'m'} eq 'tree') {
					## Tree
					&tree;
				} else {
					if ($in{'f'} eq 'f' || $in{'r'}) {
						## Replay form
						&form;
					} elsif ($in{'f'} eq 'r') {
						## Replay post
						&regist;
					} elsif ($in{'d'}) {
						## File download
						&download;
					} else {
						## View message
						&message;
					}
				}
			} else {
				if ($in{'f'} eq 'f' || $in{'r'}) {
					## Post form
					&form;
				} elsif ($in{'f'} eq 'r') {
					## Post post
					&regist;
				} else {
					## Thread
					&thread;
				}
			}
		} else {
			if ($in{'f'} eq 'f' || $in{'r'}) {
				## Create thread form
				&form;
			} elsif ($in{'f'} eq 'r') {
				## Create thread post
				&regist;
			} else {
				## Index
				&index($in{'i'});
			}
		}
	}
	## Print
	&print;

	&_exit(0);

}

sub init {

	local($altitude) = $altitude + 1;

	&_logging(7);

	$donot->{log} = 1;

	my ($tmp1,$tmp2);

	$time{'start'} = (times)[0];
	$time = time;

	$cgi = $main::cgi;
	$cgi ||= $ENV{'SCRIPT_NAME'};

	$uri = $ENV{'REQUEST_URI'};
	if ($ENV{'QUERY_STRING'} && $uri !~ /\?/) { $uri .= '?' . $ENV{'QUERY_STRING'}; }
	$url = $ENV{'HTTP_HOST'} . $uri;

	## Check configuration file
	$tmp1 = (stat("./$RCFILE"))[9];
	if ($tmp1 eq (split(',',&_open(0,"./$RCFILE.cache")))[0] && -f "./$RCFILE.cache") {
		eval("%SET = (" . &_open(1,"./$RCFILE.cache") . ");");
	} else {
		## New or NotFound
		## Create file
		$tmp2 = "$tmp1,$time\n";
		&setting(\%SET,"./$RCFILE","$ENV{'HOME'}/$RCFILE");
		foreach (keys %SET) {
			$tmp2 .= "'$_'=>'$SET{$_}',";
		}
		&_write("./$RCFILE.cache",$tmp2);
		&_cache_flush;
	}

	$donot->{log} = 0;

	## Parse CGI paramater
	&decode;

	if (!$SET{'USER_DIR'}) { &error($TEXT{'ERROR_MSG_USER_DIR_NF'}); }

	## Security
	$in{'id'} =~ s/\.\.\///g;

	## Design select
	if ($in{'design'}) {
		$in{'design'} .= "/";
	}

	# User config(over write)
	if ($in{'id'}) {
		&setting(\%SET,"$SET{'USER_DIR'}/$in{'id'}/$RCFILE");
	}
	# System config(over write)
	&setting(\%SET,"/etc/bforum/$RCFILE");
	if ($in{'id'}) {
		# System user config(over write)
		&setting(\%SET,"/etc/bforum/$in{'id'}/$RCFILE");
	}

	## Language import
	&language;

	&browser;

	&plugin;

	## Default value
	$SET{'COMPRESS_LEVEL'} ||= 1;
	$SET{'LOCK_RETRY'} ||= 5;
	$SET{'LOCK_FREE'} ||= 60;
	$SET{'COOKIE_TIME'} ||= 90 * 60 * 60 * 24;
	$TEXT{'TIME_FORMAT'} ||= "%YYYY/%MM/%DD %hh:%mm";
	$TEXT{'MONTH_FORMAT'} ||= "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec";
	$TEXT{'WEEK_FORMAT'} ||= "Sun,Mon,Thu,Wed,Thu,Fri,Sat";
	$TEXT{'AP_FORMAT'} ||= "AM,PM";
	$TEXT{'TIME_ZONE'} ||= "JST-9";
	$SET{'INDEX_NUMBER'} ||= 40;
	$SET{'LIST_NUMBER'} ||= 40;
	$SET{'TREE_NUMBER'} ||= 40;
	$SET{'TREE_STAGE'} ||= "ul";
	$TEXT{'DISP_BACK_NL'} ||= $TEXT{'DISP_BACK'};
	$TEXT{'DISP_NEXT_NL'} ||= $TEXT{'DISP_NEXT'};
	$TEXT{'DISP_INDEX_BACK_NL'} ||= $TEXT{'DISP_INDEX_BACK'};
	$TEXT{'DISP_INDEX_NEXT_NL'} ||= $TEXT{'DISP_INDEX_NEXT'};
	$TEXT{'DISP_LIST_NL'} ||= $TEXT{'DISP_LIST'};
	$TEXT{'DISP_LIST_BACK_NL'} ||= $TEXT{'DISP_LIST_BACK'};
	$TEXT{'DISP_LIST_NEXT_NL'} ||= $TEXT{'DISP_LIST_NEXT'};
	$TEXT{'DISP_TREE_NL'} ||= $TEXT{'DISP_TREE'};
	$TEXT{'DISP_TREE_BACK_NL'} ||= $TEXT{'DISP_TREE_BACK'};
	$TEXT{'DISP_TREE_NEXT_NL'} ||= $TEXT{'DISP_TREE_NEXT'};
	$TEXT{'DISP_SEARCH_NL'} ||= $TEXT{'DISP_SEARCH'};
	$TEXT{'DISP_SEARCH_BACK_NL'} ||= $TEXT{'DISP_SEARCH_BACK'};
	$TEXT{'DISP_SEARCH_NEXT_NL'} ||= $TEXT{'DISP_SEARCH_NEXT'};

	if (($SET{'NKF'} || $SET{'JCODE'}) && ($code[1] || $in{'f'} eq 'r' || $in{'f'} eq 'f' || $QUERY[0] eq 'Check') && %in) {
		foreach (keys %in) {
			&code(\$in{$_},'euc');
		}
	}

	## åǥ쥯ȥå
	## NTǺƹͤ;Ϥ
#	if ($SET{'CACHE_DO'} ne 'N' && !-w "$SET{'USER_DIR'}/.cache") { &error($TEXT{'ERROR_MSG_CACHE'}); }

}

sub portal {

	local($altitude) = $altitude + 1;

	&_logging(7);

	$portal = &_bfopen("BF.portal");

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);

	$tmp1 = $portal;

	while ($portal =~ /{(.+?):(.+?)}/go) {
		undef %status;
		&_analysis(\%status,"$SET{'USER_DIR'}/$1/status");
		$tmp2 = "$1:$2";
		if (%status) {
			if ($2 eq 'url') {
				$print{$tmp2} = $cgi . '?' . $1;
			} elsif ($2 eq 'thread') {
				$print{$tmp2} = $status{'thread'};
			} elsif ($2 eq 'log') {
				$print{$tmp2} = $status{'log'};
			} elsif ($2 eq 'date') {
				$print{$tmp2} = &_time($status{'date'});
			} elsif ($2 =~ /date:(.+)/o) {
				$print{$tmp2} = &_time($status{'date'},$1);
			} else {
				$print{$tmp2} = "";
			}
		} else {
			$print{$tmp2} = "$SET{'USER_DIR'}/$1/status";
		}
	}

	&change($tmp1,\%print);
	undef %print;

	$donot->{cache} = 1;
	$print .= $tmp1;

}

sub create {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	if (-d "$SET{'USER_DIR'}/$in{'id'}" && -z "$SET{'USER_DIR'}/$in{'id'}/index") {

		&_logging(6,"\"index\" found");

		$in{'t'} = ((stat "$SET{'USER_DIR'}/$in{'id'}/index")[9] || $time);

		local ($SET{'TITLE_LENGTH'}) = "";
		&_analysis(\%create,"$SET{'USER_DIR'}/$in{'id'}/.default","$SET{'USER_DIR'}/.default") || &error;
		$create{'message'} =~ s/\n<br\s*?\/?>\n/\n/go;
		chomp ($create{'message'});
		$create{'new'} = "Author: $create{'author'}\n";
		$create{'new'} .= "Email: $create{'email'}\n";
		$create{'new'} .= "Title: $create{'title'}\n";
		$create{'new'} .= "No: 1\n";
		$create{'new'} .= "Address: System\n";
		$create{'new'} .= "Host: System\n";
		$create{'new'} .= "Agent: System\n";
		$create{'new'} .= "Date: $in{'t'}\n\n";
		$create{'new'} .= $create{'message'};

		$no = 1;

		if (&_lock) {

			&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1",$create{'new'});
			&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/count","1");
			&_write("$SET{'USER_DIR'}/$in{'id'}/index","$in{'t'}\n");
			&_write("$SET{'USER_DIR'}/$in{'id'}/index.create","$in{'t'}\n");
			&_write("$SET{'USER_DIR'}/$in{'id'}/index.posts","$in{'t'}\n");
			&_write("$SET{'USER_DIR'}/$in{'id'}/last",$create{'new'});

			&_logging(6,"files are created");

			&mknmz;

			&status;

		}

		return ("$in{'t'}\n");

	} else {

		&about;

	}

}

sub about {

	local($altitude) = $altitude + 1;

	&_logging(7);

	undef $head;
	undef $foot;

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);

	$tmp1 = &_bfopen("BF.about");

	$print{'url'} = $ENV{'HTTP_HOST'} . $ENV{'REQUEST_URI'};
	if ($ENV{'QUERY_STRING'} && $print{'url'} !~ /\?/) { $print{'url'} .= '?' . $ENV{'QUERY_STRING'}; }

	&change($tmp1,\%print);
	undef %print;

	&do($tmp1);

	$print = $tmp1;

	if ($_[0]) { $WARNING{'about'} = "\[$_[0]\]"; }
	$WARNING{'about'} .= "Called by " . (caller)[2] . '@' . (caller)[1];

	$donot->{cache} = 1;

	&print;

	&_exit(0);

}

sub index {

	local($altitude) = $altitude + 1;

	&_logging(7);

	$donot->{cache} = 1;

	$head = &_bfopen("BF.index.head");
	$foot = &_bfopen("BF.index.foot");
	$index = &_bfopen("BF.index");

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7);
	my (@tmp8);
	my (%tmp9);

	$in{'i'} ||= lc($SET{'INDEX_SORT'});
	@tmp8 = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/index");
	if (!@tmp8) {
		@tmp8 = (&create);
	} elsif ($in{'i'} eq "create") {
		if (-s "$SET{'USER_DIR'}/$in{'id'}/index" ne -s "$SET{'USER_DIR'}/$in{'id'}/index.create") {
			&indexsort;
		}
		@tmp8 = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/index.create");
	} elsif ($in{'i'} eq "posts") {
		if (-s "$SET{'USER_DIR'}/$in{'id'}/index" ne -s "$SET{'USER_DIR'}/$in{'id'}/index.posts") {
			&indexsort;
		}
		@tmp8 = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/index.posts");
	} elsif ($in{'i'} eq "count") {

		foreach $tmp6 (@tmp8) {

			chomp($tmp6);

			$tmp9{$tmp6} = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$tmp6/count") || 1;

		}

		undef @tmp8;
		foreach (sort { $tmp9{$a} <=> $tmp9{$b} } keys %tmp9) {
			unshift (@tmp8,"$_\n");
		}

	}

	if ($in{'o'} eq "desc") {
		@tmp8 = reverse(@tmp8);
	}

	if (defined $in{'s'} && $in{'s'} < 1) { &about; }
	$in{'s'} ||= 1;
	$tmp1 = 0;
	$line = 0;
	while (1) {

		local ($in{'t'}) = $tmp8[$tmp1];

		chomp($in{'t'});
		if (!$in{'t'}) { last; }

		if (!&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1")) {
			splice (@tmp8,$tmp1,1);
			next;
		}


		$tmp1 ++;

		if ($tmp1 > ($in{'s'} * $SET{'INDEX_NUMBER'})) {
			last;
		} elsif ($tmp1 > (($in{'s'} - 1) * $SET{'INDEX_NUMBER'})) {

			$line++;

			undef %index;
			undef %last;

			$index{'number'} = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list") + 1;

			&_analysis(\%last,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$index{'number'}");
			foreach (keys %last) {
				$index{$_ . ":last"} = $last{$_};
			}

			&_analysis(\%index,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1");
			$index{'count'} = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/count") || "1";

			$index{'new'} = "";
			if ($index{'date:last'} + $SET{'NEW_TIME'} > $time) {
				$index{'new'} = $TEXT{'NEW_ELEM'};
			}
			if ($index =~ /{date:([^(last)]+?)}/o) { $index{"date:$1"} = &_time($index{'date'},$1); }
			if ($index =~ /{date:last:(.+?)}/o) { $index{"date:last:$1"} = &_time($index{'date:last'},$1); }
			&_time($index{'date'});
			&_time($index{'date:last'});

			if ($index =~ /{thread\((.+?)\)}/o) { $index{"thread($1)"} = &_link("id=$in{'id'}&t=$in{'t'}",&_cut($index{'full_title'},$1,'...')); }
			if ($index =~ /{title\((.+?)\)}/o) { $index{"title($1)"} = &_cut($index{'full_title'},$1,'...'); }
			$index{'thread'} = &_link("id=$in{'id'}&t=$in{'t'}",$index{'title'});
			$index{'thread:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}";

			&tag($index{'message'});

			&_autolink($index{'message'});

			# HTML -> XHTML
			&_xhtmlcheck($index{'message'});

			$index{'message'} =~ s/(^|\n)(\s*((&gt;|)(&gt;||\s*)*)[^\n]*)/$1<span class="quotation">$2<\/span>/go;
			$index{'message'} =~ s/(^|\n)(\s*((#|)(#||\s*)*)[^\n]*)/$1<span class="comment">$2<\/span>/go;

			$tmp2 = $index;

			&do($tmp2);
			&change($tmp2,\%index);
			$tmp3 .= $tmp2;

		}

	}

	if ((($in{'s'} - 1) * $SET{'INDEX_NUMBER'}) >= (@tmp8)) { &about; }
	if ($in{'s'} < 2) {
		$print{'back'} = $TEXT{'DISP_INDEX_BACK_NL'};
	} else {
		if ($in{'s'} eq "2" && $in{'i'}) {
			$print{'back'} = &_link("id=$in{'id'}&i=$in{'i'}",$TEXT{'DISP_INDEX_BACK'});
		} elsif ($in{'s'} eq "2") {
			$print{'back'} = &_link($in{'id'},$TEXT{'DISP_INDEX_BACK'});
		} elsif ($in{'i'}) {
			$print{'back'} = &_link("id=$in{'id'}&i=$in{'i'}&s=" . ($in{'s'} - 1),$TEXT{'DISP_INDEX_BACK'});
		} else {
			$print{'back'} = &_link("id=$in{'id'}&s=" . ($in{'s'} - 1),$TEXT{'DISP_INDEX_BACK'});
		}
	}
	if (($in{'s'} * $SET{'INDEX_NUMBER'}) >= (@tmp8)) {
		$print{'next'} = $TEXT{'DISP_INDEX_NEXT_NL'};
	} elsif ($in{'i'}) {
		$print{'next'} = &_link("id=$in{'id'}&i=$in{'i'}&s=" . ($in{'s'} + 1),$TEXT{'DISP_INDEX_NEXT'});
	} else {
		$print{'next'} = &_link("id=$in{'id'}&s=" . ($in{'s'} + 1),$TEXT{'DISP_INDEX_NEXT'});
	}

	## 硼ȥå
	$print{'page'} = $TEXT{'DISP_INDEX_PAGE_BEGIN'};
	if (@tmp8 % $SET{'INDEX_NUMBER'}) {
		$tmp5 = int(@tmp8 / $SET{'INDEX_NUMBER'}) + 1;
	} else {
		$tmp5 = int(@tmp8 / $SET{'INDEX_NUMBER'});
	}

	undef $tmp7;
	foreach (1 .. $tmp5) {

		if (!$SET{'INDEX_PAGE_SHOW'} || abs($_ - $in{'s'}) < ($SET{'INDEX_PAGE_SHOW'} / 2) || abs($_ - 1) < $SET{'INDEX_PAGE_SHOW'} || abs($_ - $tmp5) < $SET{'INDEX_PAGE_SHOW'}) {

			if ($_ ne "1" && $tmp7) {
				## ǸǤϤʤ
				$print{'page'} .= $TEXT{'DISP_INDEX_PAGE_BAR'};
			}

			if ($_ == $in{'s'}) {
				$print{'page'} .= $_;
			} else {
				if ($_ == 1 && $in{'i'}) {
					$print{'page'} .= &_link("id=$in{'id'}&i=$in{'i'}",$_);
				} elsif ($_ == 1) {
					$print{'page'} .= &_link($in{'id'},$_);
				} elsif ($in{'i'}) {
					$print{'page'} .= &_link("id=$in{'id'}&i=$in{'i'}&s=" . $_,$_);
				} else {
					$print{'page'} .= &_link("id=$in{'id'}&s=" . $_,$_);
				}
			}

			$tmp7 = 1;

		} elsif($tmp7) {

			$print{'page'} .= $TEXT{'DISP_INDEX_PAGE_NULL'};
			undef $tmp7

		}

	}
	$print{'page'} .= $TEXT{'DISP_INDEX_PAGE_END'};



	$print{'index:update:url'} = "$cgi?$in{'id'}";
	$print{'index:create:url'} = "$cgi?id=$in{'id'}&i=create";
	$print{'index:posts:url'} = "$cgi?id=$in{'id'}&i=posts";
	$print{'index:count:url'} = "$cgi?id=$in{'id'}&i=count";

	if ($in{'o'} ne "desc") {
		if ($in{'i'} eq "create") {
			$print{'index:create:url'} = "$cgi?id=$in{'id'}&i=create&o=desc";
		} elsif ($in{'i'} eq "posts") {
			$print{'index:posts:url'} = "$cgi?id=$in{'id'}&i=posts&o=desc";
		} elsif ($in{'i'} eq "count") {
			$print{'index:count:url'} = "$cgi?id=$in{'id'}&i=count&o=desc";
		} else {
			$print{'index:update:url'} = "$cgi?id=$in{'id'}&o=desc";
		}
	}

	## Order
	if ($in{'o'} ne "desc") {
		if ($in{'i'} eq "create") {
			$print{'index:create:order'} = $TEXT{'DISP_INDEX_ORDER_ASC'};
		} elsif ($in{'i'} eq "posts") {
			$print{'index:posts:order'} = $TEXT{'DISP_INDEX_ORDER_ASC'};
		} elsif ($in{'i'} eq "count") {
			$print{'index:count:order'} = $TEXT{'DISP_INDEX_ORDER_ASC'};
		} else {
			$print{'index:update:order'} = $TEXT{'DISP_INDEX_ORDER_ASC'};
		}
	} else {
		if ($in{'i'} eq "create") {
			$print{'index:create:order'} = $TEXT{'DISP_INDEX_ORDER_DESC'};
		} elsif ($in{'i'} eq "posts") {
			$print{'index:posts:order'} = $TEXT{'DISP_INDEX_ORDER_DESC'};
		} elsif ($in{'i'} eq "count") {
			$print{'index:count:order'} = $TEXT{'DISP_INDEX_ORDER_DESC'};
		} else {
			$print{'index:update:order'} = $TEXT{'DISP_INDEX_ORDER_DESC'};
		}
	}



	$tmp4 = $head . $tmp3 . $foot;
	&change($tmp4,\%print);
	undef %print;

	$print .= $tmp4;

}

sub thread {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	&message;
	&list;

}

sub message {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if($in{'m'}) {
		$message = &_bfopen("BF.message");
	} else {
		$in{'m'} = 1;
		$message = &_bfopen("BF.thread.head");
	}

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);
	my (@tmp7,@tmp8);

	if (!defined &_indexcheck($in{'id'},$in{'t'})) { &about; }

	&_analysis(\%message,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$in{'m'}");

	if (!$message{'no'}) { &about; }

	$message{'number'} = $num + 1;

	$message{'new'} = "";
	if ($message{'date'} + $SET{'NEW_TIME'} > $time) {
		$message{'new'} = $TEXT{'NEW_ELEM'};
		$donot->{cache} = 1;
	}
	if ($message =~ /{date:(.+?)}/o) { $message{"date:$1"} = &_time($message{'date'},$1); }
	&_time($message{'date'});

	if ($message{'delete'} || !&_listcheck($in{'id'},$in{'t'},$in{'m'})) {
		$message{'title'} = $TEXT{'DELETE_PREFIX'} . $message{'title'};
		&_analysis(\%message,"$SET{'USER_DIR'}/$in{'id'}/BF.delete","$SET{'USER_DIR'}/BF.delete");
		$message{'email'} = $SET{'ADDRESS'};
	}

	if ($message =~ /{title\((.+?)\)}/o) { $message{"title($1)"} = &_cut($message{'full_title'},$1,'...'); }

	&tag($message{'message'});

	&_autolink($message{'message'});

	# HTML -> XHTML
	&_xhtmlcheck($message{'message'});

	$message{'message'} =~ s/(^|\n)(\s*((&gt;|)(&gt;||\s*)*)[^\n]*)/$1<span class="quotation">$2<\/span>/go;
	$message{'message'} =~ s/(^|\n)(\s*((#|)(#||\s*)*)[^\n]*)/$1<span class="comment">$2<\/span>/go;

	$tmp2 = int(($in{'m'} - 1) / $SET{'LIST_NUMBER'}) + 1;

	$tmp1 = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");
	if ($in{'m'} eq '1') {
		$tmp3 = int(($tmp1 - 1) / $SET{'TREE_NUMBER'}) + 1;
		$in{'s'} ||= 1;
	} else {
		foreach (0 .. $tmp1) {
			if ($in{'m'} eq (split(/<0>/,&_open($_,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[0]) {
				$tmp3 = int($_ / $SET{'TREE_NUMBER'}) + 1;
				last;
			}
		}
	}

	## Referer
	if ($message{'referer'}) {
		$message{'msg:referer:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&m=$message{'referer'}";
		$message{'msg:referer'} = $TEXT{'DISP_REFERER_PREFIX'} . &_link("id=$in{'id'}&t=$in{'t'}&m=$message{'referer'}",($TEXT{'DISP_REFERER_NUMBER_PREFIX'} . $message{'referer'} . $TEXT{'DISP_REFERER_NUMBER_SUFFIX'})) . $TEXT{'DISP_REFERER_SUFFIX'};
	}

	## Responce
	undef $tmp6;
	foreach (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")) {

		chomp($_);

		if ((split(/<0>/,$_))[0] eq $in{'m'}) {
			$tmp6 = (split(/<0>/,$_))[1];
			next;
		}

		if (defined $tmp6 && (split(/<0>/,$_))[1] <= $tmp6) {
			last;
		}

		if (defined $tmp6 && (split(/<0>/,$_))[1] == ($tmp6 + 1)) {
			push (@tmp7,(split(/<0>/,$_))[0]);
		}

	}

	if (@tmp7) {
		$message{'msg:response'} = $TEXT{'DISP_RESPONSE_PREFIX'} . join($TEXT{'DISP_RESPONSE_BAR'},map { &_link("id=$in{'id'}&t=$in{'t'}&m=$_",($TEXT{'DISP_RESPONSE_NUMBER_PREFIX'} . $_ . $TEXT{'DISP_RESPONSE_NUMBER_SUFFIX'})) } @tmp7) . $TEXT{'DISP_RESPONSE_SUFFIX'};
	}

	## Files
	foreach (split(/,/,$message{'files'})) {
		push (@tmp8,$_);
	}
	if (@tmp8) {
		$message{'msg:files'} = $TEXT{'DISP_FILES_PREFIX'} . join($TEXT{'DISP_FILES_BAR'},map { &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&d=$_",($TEXT{'DISP_FILES_NUMBER_PREFIX'} . $_ . $TEXT{'DISP_FILES_NUMBER_SUFFIX'})) } @tmp8) . $TEXT{'DISP_FILES_SUFFIX'};
	}

	&_analysis(\%thread,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1");
	foreach (keys %thread) {
		$message{$_ . ":thread"} = $thread{$_};
	}

	$tmp4 = $message;

	&do($tmp4);
	&change($tmp4,\%message);

	if ($in{'m'} <= 1) {
		$print{'back'} = $TEXT{'DISP_BACK_NL'};
	} else {
		$tmp5 = $in{'m'} - 1;
		$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$tmp5",$TEXT{'DISP_BACK'});
	}

	if ($in{'m'} >= $message{'number'}) {
		$print{'next'} = $TEXT{'DISP_NEXT_NL'};
	} else {
		$tmp5 = $in{'m'} + 1;
		$print{'next'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$tmp5",$TEXT{'DISP_NEXT'});
	}

	if (!$_[0] && $message{'number'} ne '1') {
		$print{'tree'} = &_link("id=$in{'id'}&t=$in{'t'}&m=tree&s=$tmp3",$TEXT{'DISP_TREE'});
	} else {
		$print{'tree'} = $TEXT{'DISP_TREE_NL'};
	}
	$print{'list:url'} = "id=$in{'id'}&t=$in{'t'}&m=list&s=$tmp2";
	$print{'tree:url'} = "id=$in{'id'}&t=$in{'t'}&m=tree&s=$tmp3";
	$print{'list'} = &_link("id=$in{'id'}&t=$in{'t'}&m=list&s=$tmp2",$TEXT{'DISP_LIST'});

	&change($tmp4,\%print);
	undef %print;

	$print .= $tmp4;

}

sub download {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);

	$in{'d'} =~ s/\/(.*)/$1/g;

	&_analysis(\%download,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$in{'m'}");

	if ($download{($in{'d'})}) {
		## ¸ե̾
		$tmp1 = "Content-Disposition: attachment; filename=\"$download{($in{'d'})}\"\n";
	}
	$tmp1 .= &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/files/$in{'t'}/$in{'m'}/$in{'d'}");

	if ($donot->{body}) {
		$tmp1 = (split(/\n{2}/,$tmp1))[0];
	}

	if ($tmp1) {

		$tmp2 = select (STDOUT);
		binmode (STDOUT);
		print $tmp1;
		select ($tmp2);
		&_exit(0);

	} else {

		&about;

	}

}

sub list {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if ($in{'m'} eq 'list') {
		$head = &_bfopen("BF.list.head");
		$foot = &_bfopen("BF.list.foot");
		$list = &_bfopen("BF.list");
	} else {
		$head = undef;
		$foot = &_bfopen("BF.thread.foot");
		$list = &_bfopen("BF.thread");
	}

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);

	if (!defined &_indexcheck($in{'id'},$in{'t'})) { &about; }

	if ($in{'s'} < 1) { &about; }
	$in{'s'} ||= 1;
	$line = 0;
	foreach (((($in{'s'} - 1) * $SET{'LIST_NUMBER'} + 1) .. ($in{'s'} * $SET{'LIST_NUMBER'}))) {

		undef %list;

		if (($num + 2 - $_) < 0) { last; }

		if (&_analysis(\%list,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/" . ($num + 2 - $_))) {

			$line++;

			$list{'new'} = "";
			if ($list{'date'} + $SET{'NEW_TIME'} > $time) {
				$list{'new'} = $TEXT{'NEW_ELEM'};
				$donot->{cache} = 1;
			}
			if ($list =~ /{date:(.+?)}/o) { $list{"date:$1"} = &_time($list{'date'},$1); }
			&_time($list{'date'});
			if ($list{'delete'} || !&_listcheck($in{'id'},$in{'t'},$_)) {
				$list{'title'} = $TEXT{'DELETE_PREFIX'} . $list{'title'};
				&_analysis(\%list,"$SET{'USER_DIR'}/$in{'id'}/BF.delete","$SET{'USER_DIR'}/BF.delete");
				$list{'email'} = $SET{'ADDRESS'};
			}
			if ($list =~ /{title:(.+?)}/o && $1 =~ /^\d*$/o) { $list{"title:$1"} = &_link("id=$in{'id'}&t=$in{'t'}&m=$list{'no'}",&_cut($list{'full_title'},$1,'...')); }
			$list{'title:nl'} = $list{'full_title'};
			$list{'title'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$list{'no'}",$list{'title'});

			$tmp1 = $list;
			&do($tmp1);
			&change($tmp1,\%list);

			$tmp2 .= $tmp1;

		}
	}


	&_analysis(\%thread,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1");
	foreach (keys %thread) {
		$print{$_ . ":thread"} = $thread{$_};
	}

	$tmp4 = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");

	if ((($in{'s'} - 1) * $SET{'LIST_NUMBER'}) > ($tmp4 + 1)) { &about; }

	if ($in{'s'} == 1) {
		$print{'back'} = $TEXT{'DISP_LIST_BACK_NL'};
	} else {
		$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&m=list&s=" . ($in{'s'} - 1),$TEXT{'DISP_LIST_BACK'});
	}
	if ($in{'s'} > int($tmp4 / $SET{'LIST_NUMBER'})) {
		$print{'next'} = $TEXT{'DISP_LIST_NEXT_NL'};
	} else {
		$print{'next'} = &_link("id=$in{'id'}&t=$in{'t'}&m=list&s=" . ($in{'s'} + 1),$TEXT{'DISP_LIST_NEXT'});
	}

	if ($in{'m'} eq 'list') { $print{'list'} = $TEXT{'DISP_LIST_NL'}; }
	if (!$num) {
		$print{'tree'} = $TEXT{'DISP_TREE_NL'};
	} else {
		$print{'tree'} = &_link("id=$in{'id'}&t=$in{'t'}&m=tree&s=1",$TEXT{'DISP_TREE'});
	}

	## 硼ȥå
	$print{'page'} = $TEXT{'DISP_LIST_PAGE_BEGIN'};
	## Nextɬ
	$tmp5 = int(($tmp4 - (1 % $SET{'LIST_NUMBER'})) / $SET{'LIST_NUMBER'}) + 1;

	undef $tmp6;
	foreach (1 .. $tmp5) {

		if (!$SET{'TREE_PAGE_SHOW'} || abs($_ - $in{'s'}) < ($SET{'TREE_PAGE_SHOW'} / 2) || abs($_ - 1) < $SET{'TREE_PAGE_SHOW'} || abs($_ - $tmp5) < $SET{'TREE_PAGE_SHOW'}) {

			if ($_ == $in{'s'}) {
				$print{'page'} .= $_;
			} else {
				$print{'page'} .= &_link("id=$in{'id'}&t=$in{'t'}&m=list&s=" . $_,$_);
			}

			if ($tmp5 ne $_) {
				## ǸǤϤʤ
				$print{'page'} .= $TEXT{'DISP_LIST_PAGE_BAR'};
			}

			$tmp6 = 1;

		} elsif ($tmp6) {

			$print{'page'} .= $TEXT{'DISP_LIST_PAGE_NULL'};
			undef $tmp6;

		}

	}
	$print{'page'} .= $TEXT{'DISP_LIST_PAGE_END'};


	$tmp3 = $head . $tmp2 . $foot;
	&change($tmp3,\%print);
	undef %print;

	$print .= $tmp3;

}

sub tree {

	local($altitude) = $altitude + 1;

	&_logging(7);

	$head = &_bfopen("BF.tree.head");
	$foot = &_bfopen("BF.tree.foot");
	$tree = &_bfopen("BF.tree");

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7);
	my (@tmp8);

	if (!defined &_indexcheck($in{'id'},$in{'t'})) { &about; }

	if (defined $in{'s'} && $in{'s'} < 1) { &about; }
	$in{'s'} ||= 1;
	$tmp1 = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list") + 1;
	$tmp2 = ($in{'s'}) * $SET{'TREE_NUMBER'};
	$line = 0;
	foreach (reverse(1 .. $SET{'TREE_NUMBER'})) {

		undef %tree;

		$tree{'number'} = (split(/<0>/,&_open(($tmp2 - $_),"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[0] || 1;
		if ($tmp1 <= ($tmp2 - $_)) { next; }

		$line++;

		&_analysis(\%tree,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$tree{'number'}");

		if ($tree{'number'} == 1) {
			$tmp8[$tree{'number'}] = (split(/<0>/,&_open(($tmp2 - $_),"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[1];
		} else {
			$tmp8[$tree{'number'}] = (split(/<0>/,&_open(($tmp2 - $_),"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[1] + 1;
		}

		$tree{'new'} = "";
		if ($tree{'date'} + $SET{'NEW_TIME'} > $time) {
			$tree{'new'} = $TEXT{'NEW_ELEM'};
			$donot->{cache} = 1;
		}
		if ($tree =~ /{date:(.+?)}/o) { $tree{"date:$1"} = &_time($tree{'date'},$1); }
		&_time($tree{'date'});
		if ($tree{'delete'}) {
			$tree{'title'} = $TEXT{'DELETE_PREFIX'} . $tree{'title'};
			&_analysis(\%tree,"$SET{'USER_DIR'}/$in{'id'}/BF.delete","$SET{'USER_DIR'}/BF.delete");
			$tree{'email'} = $SET{'ADDRESS'};
		}
		if ($tree =~ /{title:(.+?)}/o) { $tree{"title:$1"} = &_link("id=$in{'id'}&t=$in{'t'}&m=$tree{'no'}",&_cut($tree{'full_title'},$1,'...')); }
		$tree{'title'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$tree{'no'}",$tree{'title'});

		$tmp3 = ("<$SET{'TREE_STAGE'}>" x $tmp8[$tree{'number'}]) . $tree . ("</$SET{'TREE_STAGE'}>" x $tmp8[$tree{'number'}]);
		&do($tmp3);
		&change($tmp3,\%tree);
		$tmp4 .= $tmp3;

	}

	&_analysis(\%thread,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1");
	foreach (keys %thread) {
		$print{$_ . ":thread"} = $thread{$_};
	}

	if ((($in{'s'} - 1) * $SET{'TREE_NUMBER'}) >= $tmp1) { &about; }

	if ($in{'s'} < 2) {
		$print{'back'} = $TEXT{'DISP_TREE_BACK_NL'};
	} else {
		if ($in{'s'} == 1) {
			$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&m=tree",$TEXT{'DISP_TREE_BACK'});
		} else {
			$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&m=tree&s=" . ($in{'s'} - 1),$TEXT{'DISP_TREE_BACK'});
		}
	}
	if (($in{'s'} * $SET{'TREE_NUMBER'}) >= $tmp1) {
		$print{'next'} = $TEXT{'DISP_TREE_NEXT_NL'};
	} else {
		$print{'next'} = &_link("id=$in{'id'}&t=$in{'t'}&m=tree&s=" . ($in{'s'} + 1),$TEXT{'DISP_TREE_NEXT'});
	}

	$print{'list'} = &_link("id=$in{'id'}&t=$in{'t'}&m=list&s=1",$TEXT{'DISP_LIST'});
	$print{'tree'} = $TEXT{'DISP_TREE_NL'};

	## 硼ȥå
	$print{'page'} = $TEXT{'DISP_TREE_PAGE_BEGIN'};
	## Nextɬ
	$tmp5 = int(($tmp1 - (1 % $SET{'TREE_NUMBER'}) - 1) / $SET{'TREE_NUMBER'}) + 1;

	undef $tmp6;
	foreach (1 .. $tmp5) {

		if (!$SET{'TREE_PAGE_SHOW'} || abs($_ - $in{'s'}) < ($SET{'TREE_PAGE_SHOW'} / 2) || abs($_ - 1) < $SET{'TREE_PAGE_SHOW'} || abs($_ - $tmp5) < $SET{'TREE_PAGE_SHOW'}) {

			if ($_ == $in{'s'}) {
				$print{'page'} .= $_;
			} else {
				$print{'page'} .= &_link("id=$in{'id'}&t=$in{'t'}&m=tree&s=" . $_,$_);
			}

			if ($tmp5 ne $_) {
				## ǸǤϤʤ
				$print{'page'} .= $TEXT{'DISP_TREE_PAGE_BAR'};
			}

			$tmp6 = 1;

		} elsif ($tmp6) {

				$print{'page'} .= $TEXT{'DISP_TREE_PAGE_NULL'};
				undef $tmp6;

		}

	}
	$print{'page'} .= $TEXT{'DISP_TREE_PAGE_END'};


	$tmp7 = $head . $tmp4 . $foot;
	&change($tmp7,\%print);
	undef %print;

	$print .= $tmp7;

}

sub search {

	local($altitude) = $altitude + 1;

	&_logging(7);

	$head = &_bfopen("BF.search.head");
	$foot = &_bfopen("BF.search.foot");
	$search = &_bfopen("BF.search");

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);
	my (@tmp7);

	if ($SET{'NAMAZU'}) {

		## Search Namazu

		if (defined $in{'s'} && $in{'s'} < 1) { &about; }
		$in{'s'} ||= 1;

		## Not CGI
		$tmp2 = $ENV{'SCRIPT_NAME'};
		delete $ENV{'SCRIPT_NAME'};

		@tmp7 = ($SET{'NAMAZU'},"--list","--sort=\"$in{'search.sort'}\"","--config=\"$SET{'NAMAZU_CONFIG'}\"");

		if ($in{'search.order'} eq "ascending") {
			push(@tmp7,"--ascending");
		}

		push(@tmp7,$in{'search.query'});

		if (ref $in{'search.idxname'}) {
			foreach (@{$in{'search.idxname'}}) {
				push(@tmp7,"$SET{'NAMAZU_INDEX'}/$_");
			}
		} elsif ($in{'search.idxname'}) {
			push(@tmp7,"$SET{'NAMAZU_INDEX'}/$in{'search.idxname'}");
		} else{
			push(@tmp7,$SET{'NAMAZU_INDEX'});
		}

		open (NAMAZU,"@tmp7 |");
		binmode (NAMAZU);
		undef $line;
		foreach (<NAMAZU>) {

			if ($_ =~ /id=(.*?)&t=(.*?)&m=([^\n\r\&]*)/) {

				my (%in) = %in;

				$in{'id'} = $1;
				$in{'t'} = $2;
				$in{'m'} = $3;

				undef %search;

				if (&_analysis(\%search,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$in{'m'}")) {

					$line++;

					if ($line > (($in{'s'} - 1) * $SET{'SEARCH_NUMBER'}) && $line <= ($in{'s'} * $SET{'SEARCH_NUMBER'})) {

						$search{'new'} = "";
						if ($search{'date'} + $SET{'NEW_TIME'} > $time) {
							$search{'new'} = $TEXT{'NEW_ELEM'};
							$donot->{cache} = 1;
						}
						if ($search =~ /{date:(.+?)}/o) { $search{"date:$1"} = &_time($search{'date'},$1); }
						&_time($search{'date'});
						if ($search{'delete'} || !&_listcheck($in{'id'},$in{'t'},$in{'m'})) {
							$search{'title'} = $TEXT{'DELETE_PREFIX'} . $search{'title'};
							&_analysis(\%search,"$SET{'USER_DIR'}/$in{'id'}/BF.delete","$SET{'USER_DIR'}/BF.delete");
							$search{'email'} = $SET{'ADDRESS'};
						}
						if ($search =~ /{title:(.+?)}/o && $1 =~ /^\d*$/o) { $search{"title:$1"} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}",&_cut($search{'full_title'},$1,'...')); }
						$search{'title:nl'} = $search{'full_title'};
						$search{'title'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}",$search{'title'});

						&_analysis(\%thread,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1");
						foreach (keys %thread) {
							$search{$_ . ":thread"} = $thread{$_};
						}

						$tmp3 = $search;
						&do($tmp3);
						&change($tmp3,\%search);

						$tmp1 .= $tmp3;

					}

				}

			}


		}

		close (NAMAZU);

		$ENV{'SCRIPT_NAME'} = $tmp2;

		if ($line) {

			$hit = $line;

			if ((($in{'s'} - 1) * $SET{'SEARCH_NUMBER'}) >= $line) { &about; }

			if ($in{'s'} < 2) {
				$print{'back'} = $TEXT{'DISP_SEARCH_BACK_NL'};
			} else {
				if ($in{'s'} == 1) {
					$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&f=$in{'f'}&cc=$in{'cc'}&search.query=$in{'search.query'}&search=$in{'search'}&search.sort=$in{'search.sort'}&search.order=$in{'search.order'}&s=",$TEXT{'DISP_SEARCH_BACK'});
				} else {
					$print{'back'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&f=$in{'f'}&cc=$in{'cc'}&search.query=$in{'search.query'}&search=$in{'search'}&search.sort=$in{'search.sort'}&search.order=$in{'search.order'}&s=" . ($in{'s'} - 1),$TEXT{'DISP_SEARCH_BACK'});
				}
			}
			if (($in{'s'} * $SET{'SEARCH_NUMBER'}) >= $line) {
				$print{'next'} = $TEXT{'DISP_SEARCH_NEXT_NL'};
			} else {
				$print{'next'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&f=$in{'f'}&cc=$in{'cc'}&search.query=$in{'search.query'}&search=$in{'search'}&search.sort=$in{'search.sort'}&search.order=$in{'search.order'}&s=" . ($in{'s'} + 1),$TEXT{'DISP_SEARCH_NEXT'});
			}

			## 硼ȥå
			$print{'page'} = $TEXT{'DISP_SEARCH_PAGE_BEGIN'};
			## Nextɬ
			$tmp4 = int(($line - (1 % $SET{'SEARCH_NUMBER'})) / $SET{'SEARCH_NUMBER'}) + 1;

			undef $tmp5;
			foreach (1 .. $tmp4) {

				if (!$SET{'SEARCH_PAGE_SHOW'} || abs($_ - $in{'s'}) < ($SET{'SEARCH_PAGE_SHOW'} / 2) || abs($_ - 1) < $SET{'SEARCH_PAGE_SHOW'} || abs($_ - $tmp4) < $SET{'SEARCH_PAGE_SHOW'}) {

					if ($_ == $in{'s'}) {
						$print{'page'} .= $_;
					} else {
						$print{'page'} .= &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&f=$in{'f'}&cc=$in{'cc'}&search.query=$in{'search.query'}&search=$in{'search'}&search.sort=$in{'search.sort'}&search.order=$in{'search.order'}&s=" . $_,$_);
					}

					if ($tmp4 ne $_) {
						## ǸǤϤʤ
						$print{'page'} .= $TEXT{'DISP_SEARCH_PAGE_BAR'};
					}

					$tmp5 = 1;

				} elsif ($tmp5) {

						$print{'page'} .= $TEXT{'DISP_SEARCH_PAGE_NULL'};
						undef $tmp5;

				}

			}
			$print{'page'} .= $TEXT{'DISP_SEARCH_PAGE_END'};

		}

		if ($tmp1) {

			$tmp6 = $head . $tmp1 . $foot;
			&change($tmp6,\%print);
			undef %print;

			$print .= $tmp6;

		} else {

			$print .= &_bfopen("BF.search.notfound") || $TEXT{'ERROR_MSG_SEARCH_NOTFOUND'};

		}

	} else {

		## Cannot search
		$print .= $TEXT{'ERROR_MSG_CANNOT_SEARCH'};

	}

}

sub form {

	local($altitude) = $altitude + 1;

	&_logging(7);

	$form = &_bfopen("BF.form");

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);

	if ($SET{'POST_DO'} eq 'N') {
		$form = $TEXT{'ERROR_MSG_READ_ONLY'};
	} elsif (&limit) {
		$form = $TEXT{'ERROR_MSG_OVERFLOW_DATA'};
	}

	$in{'f'} = 'r';

	&_get_cookie;

	$tmp1 = $form;

	if ($in{'m'}) { &message; }
	if ($in{'t'}) { $tmp1 =~ s/{tree}/&_link("id=$in{'id'}&t=$in{'t'}&m=tree&s=$in{'s'}",$TEXT{'DISP_TREE'})/ego; }

	$in{'message'} =~ s/\\n/\n/go;

	$donot->{cache} = 1;

	$print .= $tmp1;

}

sub confirm {

	local($altitude) = $altitude + 1;

	&_logging(7);

	$confirm = &_bfopen("BF.confirm");

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);

	%confirm = %in;

	&_br($confirm{'message'});

	&tag($confirm{'message'});

	&_autolink($confirm{'message'});

	# HTML -> XHTML
	&_xhtmlcheck($confirm{'message'});

	$confirm{'message'} =~ s/(^|\n)(\s*((&gt;|)(&gt;||\s*)*)[^\n]*)/$1<span class="quotation">$2<\/span>/go;
	$confirm{'message'} =~ s/(^|\n)(\s*((#|)(#||\s*)*)[^\n]*)/$1<span class="comment">$2<\/span>/go;


	$tmp1 = $confirm;

	foreach (sort keys %in) {
		if (!($_ =~ /^(confirm|f|id|t|m|cc|plugin)$/)) {
			$tmp2 .= "<input type=\"hidden\" name=\"confirm.$_\" />\n";
			$in{"confirm.$_"} = $in{$_};
			$in{"confirm.$_"} =~ s/&amp;/&/go;
			$in{"confirm.$_"} =~ s/&lt;/</go;
			$in{"confirm.$_"} =~ s/&gt;/>/go;
			$in{"confirm.$_"} =~ s/&quot;/"/go;
			$in{"confirm.$_"} =~ s/\\\\/\\/go;
			$in{"confirm.$_"} =~ s/(\W)/'%' . unpack("H2",$1)/ego;
		}
	}

	foreach (sort keys %files) {
		$tmp2 .= "<input type=\"hidden\" name=\"file.$_\" />\n";
		$in{('file.' . $_)} = $files{$_};
		$in{('file.' . $_)} =~ s/(\W)/'%' . unpack("H2",$1)/ego;
	}

	$confirm{'passwd'} = "*" x length($confirm{'passwd'});

	$tmp1 =~ s/<form (.*?)action=(["']?)($cgi|{cgi})\2(.*?)>(.*?)\n/<form $1action=$2$3$2$4>$5\n$tmp2/io;

	&do($tmp1);
	&change($tmp1,\%confirm);

	$print .= $tmp1;

}

sub regist {

	local($altitude) = $altitude + 1;

	&_logging(7);

	$regist = &_bfopen("BF.regist");

	if (defined &plugin(undef,@_)) { return; }

	if (&limit || $SET{'POST_DO'} eq 'N') {

		&form;
		return;

	} else {

		my ($tmp1,$tmp2,$tmp3);
		my (@tmp4,@tmp5);
		my (@index,@indexnosort,@list);
		my ($log);

		if($log = &registprepare) {

			if (!$in{'t'}) {

				$in{'t'} = $time;
				&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1",$log);

			} else {

				&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$no",$log);

				@list = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list",">$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");

				if ($in{'m'} && $in{'m'} ne '1') {

					$tmp1 = 0;
					undef $tmp2;
					foreach (@list) {
						@tmp4 = split (/<0>/,$_);
						if ($tmp4[0] eq $in{'m'}) {
							$tmp2 = $tmp4[1];
						} elsif (defined $tmp2 && $tmp4[1] eq $tmp2) {
							$tmp2++;
							splice (@list,$tmp1,undef,"$no<0>$tmp2<0>\n");
							undef $tmp2;
							last;
						}
						$tmp1 ++;
					}
					if (defined $tmp2) {
						$tmp2++;
						splice (@list,$tmp1,undef,"$no<0>$tmp2<0>\n");
					}

				} else {
					unshift (@list,"$no<0>0<0>\n");
				}

				&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list",@list);

			}

			&indexsort($no);

			if ($SET{'FILE_UPLOAD_DO'} ne 'N' && %files) {
				umask (oct($SET{'UMASK'}));
				mkdir ("$SET{'USER_DIR'}/$in{'id'}/files",0777);
				mkdir ("$SET{'USER_DIR'}/$in{'id'}/files/$in{'t'}",0777);
				mkdir ("$SET{'USER_DIR'}/$in{'id'}/files/$in{'t'}/$no",0777);
				foreach (keys %files) {
					$tmp3 = $_;
					$tmp3 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
					open (FILE,">$SET{'USER_DIR'}/$in{'id'}/files/$in{'t'}/$no/$tmp3");
					binmode (FILE);
					print FILE $files{$_};
					close (FILE);
				}
			}

			&_write("$SET{'USER_DIR'}/$in{'id'}/last",$log);

			if ($in{'passwd'}) {
				if (&_use("MD5")) {
					@tmp5 = ('a' .. 'z','A' .. 'Z',0 .. 9);
					&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/.passwd",&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/.passwd") . "$no:crypt:" . crypt($in{'passwd'},($tmp5[(int(rand($#tmp5)))] . $tmp5[(int(rand($#tmp5)))])) . "\n");
				} else {
					&_write("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/.passwd",&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/.passwd") . "$no:md5:" . MD5->hexhash($in{'passwd'}) . "\n");
				}
				undef $in{'passwd'};
			}

			&_cache_flush;

			&mknmz;

			&status;

			if ($SET{'SENDMAIL_DO'} ne 'N') {

				## 
				foreach (split(/,/,lc($SET{'PTAG'}))) {
					$in{'message'} =~ s/&lt;$_.*?&gt;(.*?)&lt;\/$_&gt;/$1/egis;
				}

				foreach (split(/,/,lc($SET{'ATAG'}))) {
					$in{'message'} =~ s/&lt;$_.*?&gt;//egi;
				}

				$in{'message'} =~ s/\\\\/\\/gi;

				$in{'url'} = $ENV{'HTTP_HOST'} . $cgi . "?id=$in{'id'}&t=$in{'t'}&m=$no";
				&sendmail(&_bfopen("BF.email"),\%in);

			}

			&do($regist);
			&change($regist,\%regist);

			$print{'jump'} = "$cgi?id=$in{'id'}&t=$in{'t'}&m=$no";

			&change($regist,\%print);
			undef %print;

			$header .= &_set_cookie;
			$print .= $regist;

			$donot->{head} = 1;
			$donot->{cache} = 1;

			return;

		} else {

			return;

		}

	}

}

sub registprepare {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7);

	foreach (split(/,/,$SET{'INDISPENSABLE'})) {
		if (!$in{$_} && !$in{"nocokkie.$_"}) {
			$tmp1 = 1;
			$notice .= "$TEXT{'ERROR_MSG_NO_ITEM'}\n";
			last;
		}
	}

	if (($in{'email'} && $in{'email'} !~ /\S+\@\S+\.\S+/) || ($in{'nocookie.email'} && $in{'nocokkie.email'} !~ /\S+\@\S+\.\S+/)) {
		$tmp1 = 1;
		$notice .= "$TEXT{'ERROR_MSG_WRONG_EMAIL'}\n";
	}

	if ($SET{'FILE_UPLOAD_DO'} ne 'N') {

		## Check filesize
		foreach (keys %files) {

			if ($SET{'FILE_UPLOAD_LIMIT_' . uc($_)}) {

				## Several
				if ($SET{'FILE_UPLOAD_LIMIT_' . uc($_)} < length((split(/\n{2}/,$files{$_}))[1])) {
					$tmp1 = 1;
					$notice .= "$TEXT{'ERROR_MSG_OVERFLOW_FILE_UPLOAD'}(" . length((split(/\n{2}/,$files{$_}))[1]) . ")\n";
				}

			} elsif ($SET{'FILE_UPLOAD_LIMIT'}) {

				## Common
				if ($SET{'FILE_UPLOAD_LIMIT'} < length((split(/\n{2}/,$files{$_}))[1])) {
					$tmp1 = 1;
					$notice .= "$TEXT{'ERROR_MSG_OVERFLOW_FILE_UPLOAD'}(" . length((split(/\n{2}/,$files{$_}))[1]) . ")\n";
				}

			}

		}

	} else {

		if (%files) {
			$tmp1 = 1;
			$notice .= "$TEXT{'ERROR_MSG_WRONG_FILE_UPLOAD'}\n";
		}

	}

	if ($SET{'FILE_UPLOAD_TYPECHECK_DO'} ne 'N') {

		## Check filetype
		if (!&_use("File::Type")) {

			$tmp2 = File::Type->new();

			foreach (keys %files) {

				if ($SET{('FILE_UPLOAD_TYPE_' . uc($_))}) {

					## Several
					undef $tmp6;
					foreach $tmp7 (split(/\s+/,$SET{'FILE_UPLOAD_TYPE_' . uc($_)})) {
						if ($tmp2->checktype_contents((split(/\n{2}/,$files{$_}))[1]) eq $tmp7) {
							$tmp6 = 1;
						}
					}

					if (!$tmp6) {
						$tmp1 = 1;
						$notice .= "$TEXT{'ERROR_MSG_IGNORETYPE_FILE_UPLOAD'}(" . $tmp2->checktype_contents((split(/\n{2}/,$files{$_}))[1]) . ")\n";
					}

				} elsif ($SET{'FILE_UPLOAD_TYPE'}) {

					## Common
					undef $tmp6;
					foreach $tmp7 (split(/\s+/,$SET{'FILE_UPLOAD_TYPE'})) {
						if ($tmp2->checktype_contents((split(/\n{2}/,$files{$_}))[1]) eq $tmp7) {
							$tmp6 = 1;
						}
					}

					if (!$tmp6) {
						$tmp1 = 1;
						$notice .= "$TEXT{'ERROR_MSG_IGNORETYPE_FILE_UPLOAD'}(" . $tmp2->checktype_contents((split(/\n{2}/,$files{$_}))[1]) . ")\n";
					}

				}

			}

		}

	}

	if ($tmp1) {
		$notice .= "$TEXT{'ERROR_MSG_CANNOT_WRITE'}\n";
		undef $in{'passwd'};
		&form;
		return;
	} else {

		if ($in{'confirm'}) {
			&confirm;
			return;
		}

		$in{'host'} = $ENV{'REMOTE_HOST'};
		$in{'addr'} = $ENV{'REMOTE_ADDR'};
		if ($in{'host'} eq $in{'addr'} || $in{'host'} eq "") { $in{'host'} = gethostbyaddr(pack("C4",split(/\./,$in{'addr'})),2) || $in{'addr'}; }

		foreach (sort keys %in) {

			if ($_ =~ s/nocokkie\.//o) {
				$in{$_} = $in{"nocookie.$_"};
				delete $in{"nocookie.$_"};
			}

			if ($_ =~ /^(f|id|message|t|m|cc|plugin|passwd)$/) { next; }

			my ($tmp3);
			$tmp3 = lc ($_);
			$tmp3 = ucfirst ($tmp3);
			$tmp4 .= "$tmp3: $in{$_}\n";

		}

		if (!$in{'t'}) {
			$no = 1;
		} else {
			$no = $num + 2;
		}

		&_analysis(\%check,"$SET{'USER_DIR'}/$in{'id'}/last");

		if ($in{'author'} eq $check{'author'} && $in{'title'} eq $check{'title'} && $in{'m'} eq $check{'referer'} && $in{'addr'} eq $check{'addr'} && $in{'host'} eq $check{'host'} && $ENV{'HTTP_USER_AGENT'} eq $check{'agent'}) {

			&do($regist);
			&change($regist,\%regist);

			$print{'jump'} = "$cgi?id=$in{'id'}&t=$in{'t'}&m=$check{'no'}";

			&change($regist,\%print);
			undef %print;

			$header .= &_set_cookie;
			$print .= $regist;

			$donot->{head} = 1;
			$donot->{cache} = 1;

			return;

		}

		foreach (keys %files) {
			$tmp5 = $_;
			$tmp5 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
			$in{'files'} .= "$tmp5, ";
		}


		$tmp4 .= "No: $no\n";
		$tmp4 .= "Agent: $ENV{'HTTP_USER_AGENT'}\n";
		$tmp4 .= "Version: $VERSION(Revision:$REVISION)\n";
		$tmp4 .= "Date: $time\n";
		$tmp4 .= "Files: $in{'files'}\n";
		$tmp4 .= "Referer: $in{'m'}\n";
		$tmp4 .= "\n$in{'message'}\n";

		if (&_lock) {
			return $tmp4;
		} else {
			&form;
			return;
		}

	}

}

sub indexsort {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);
	my (@update,@create,@posts);
	my (%tmp3);

	@update = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/index");
	@posts = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/index.posts");

	foreach (@update) {

		$tmp2 = $_;
		chomp($tmp2);

		$tmp3{$tmp2} = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$tmp2/list") + 1;

	}



	## number
	if ($#update ne $#posts) {
		undef @posts;
		foreach (sort { $tmp3{$a} <=> $tmp3{$b} } keys %tmp3) {
			unshift (@posts,"$_\n");
		}
	}



	## update
	$tmp1 = 0;
	foreach (@update) {

		$tmp2 = $_;
		chomp($tmp2);

		if ($tmp2 eq $in{'t'}) {
			splice (@update,$tmp1,1);
			last;
		}

		undef $tmp2;

		$tmp1++;

	}
	if ($in{'t'}) {
		unshift (@update,"$in{'t'}\n");
	}

	## create
	@create = sort { $b <=> $a } @update;



	&_write("$SET{'USER_DIR'}/$in{'id'}/index",@update);
	&_write("$SET{'USER_DIR'}/$in{'id'}/index.create",@create);
	&_write("$SET{'USER_DIR'}/$in{'id'}/index.posts",@posts);

}

sub news {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);
	my (%news);

	foreach (&_open("file","$SET{'USER_DIR'}/$in{'id'}/index")) {

		chomp ($_);

		$tmp1 = 1;
		while (1) {

			undef %news;
			&_analysis(\%news,"$SET{'USER_DIR'}/$in{'id'}/$_/$tmp1");

			if ($news{'no'}) {

			} else {

				last;

			}

		}

	}

}

sub mknmz {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	if ($SET{'MKNMZ'}) {
		my ($tmp1);
		my (@tmp2);

		$SET{'MKNMZ'} =~ s/\\/\\\\/go;
		$tmp1 = "$cgi?id=$in{'id'}&t=$in{'t'}&m=$no";
		$tmp1 =~ s/\//\\\//go;
		$tmp1 =~ s/\&/\\&/go;
		@tmp2 = ($SET{'MKNMZ'},"allow=\"last\"","--no-encode-uri","--no-delete","--media-type=text/bforum","--replace=\"s/.*/$tmp1/\"","$SET{'USER_DIR'}/$in{'id'}/last");

		open (MKNMZ,"@tmp2 |");
		open (NMZLOG,">$SET{'USER_DIR'}/$in{'id'}/BF.mknmz.log");
		binmode (NMZLOG);
		print NMZLOG (<MKNMZ>);
		close (MKNMZ);
		close (NMZLOG);

	}

}


##
## Sendmail Ver1.02
##
sub sendmail {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	$tmp1 .= "Sender: $SET{'ADDRESS'}\n";
	$tmp1 .= "MIME-Version: 1.0\n";
	$tmp1 .= "Content-type: text/plain; Charset=ISO-2022-JP\n";
	$tmp1 .= "Content-Transfer-Encoding: 7bit\n";
	$tmp1 .= "X-Mailer: BEETAS.org B.Forum {version}(Revision:{revision})\n";

	%email = %{$_[1]};
	$email{'address'} = $SET{'ADDRESS'};
	$email{'subject'} = $email{'title'};
	$email{'message'} =~ s/&lt;/</go;
	$email{'message'} =~ s/&gt;/>/go;
	$email{'message'} =~ s/&amp;/&/go;
	$email{'message'} =~ s/&quot;/"/go;
	$email{'separator'} = ("-" x ($SET{'SENDMAIL_WRAP'} || 76));
	$email{'version'} = $VERSION;
	$email{'revision'} = $REVISION;
	$email{'host'} = $ENV{'REMOTE_HOST'};
	$email{'addr'} = $ENV{'REMOTE_ADDR'};
	if ($email{'host'} eq $email{'addr'} || $email{'host'} eq "") { $email{'host'} = gethostbyaddr(pack("C4",split(/\./,$email{'addr'})),2) || $email{'addr'}; }

	$tmp3 = $_[0];

	$tmp3 =~ s/\n\t+([\n]+)/$1/go;

	&do($tmp1);
	&change($tmp1,\%email);

	&do($tmp3);
	&change($tmp3,\%email);

	$tmp3 =~ s/From: "(.*)"/"From: \"" . &_subject($1) . "\""/ego;
	$tmp3 =~ s/Subject: (.*)/"Subject: " . &_subject($1)/ego;

	if ($SET{'SENDMAIL_WRAP'}) {
		if ($tmp3 =~ /^(.+?\n{2})(.*)$/so) {
			$tmp3 = $2;
			$tmp3 = $1 . join("\n",&_wrap($tmp3,$SET{'SENDMAIL_WRAP'}));
		}
	}

	$tmp3 =~ s/\n{2}/\n$tmp1\n/o;

	&code(\$tmp3,'jis','euc');

	if (-x (split(/\s/,$SET{'SENDMAIL'}))[0] && open(MAIL, "| $SET{'SENDMAIL'}")) {

		&_logging(4,"Sendmail");

		binmode (MAIL);
		## Хåե󥰤ߤ
		$tmp2 = select(MAIL);
		$| = 1;
		select($tmp2);

		print MAIL $tmp3;
		close (MAIL);

	} else {

		&_logging(4,"SMTP");

		$tmp4 = (split(/\n{2}/o,$tmp3,2))[0];

		if ($tmp4 =~ /From: ([^<>]*)\n/io) {
			$tmp5 = $1;
		} else {
			$tmp5 = $SET{'ADDRESS'};
		}

		while ($tmp4 =~ /(To: |Cc: |Bcc: )([^<>]*)\n/gio) {
			&smtp($tmp5,$2,$tmp3);
		}

	}

}


##
## SMTP Ver1.02
##
sub smtp {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);
	my (@tmp2);

	if (!$init{'smtp'}) {

		$init{'smtp'} = 2;

		if (!&_use("Net::DNS") && !&_use("Net::SMTP")) {
			$init{'smtp'} = 1;
		}

		&_logging(4,"SMTP Status : $init{'smtp'}");

	}

	if ($init{'smtp'} == 1) {

		@tmp2 = Net::DNS::mx((split(/@/,$_[1],2))[1]);
		warn($tmp2[0]->exchange);
		$tmp1 = Net::SMTP->new($tmp2[0]->exchange, Hello => ($ENV{'REMOTE_HOST'} || gethostbyaddr(pack("C4",split(/\./,$ENV{'REMOTE_ADDR'})),2)), Timeout => 30);

		if (defined $tmp1) {
			$tmp1->mail($_[0]);
			$tmp1->to($_[1]);
			$tmp1->data();
			$tmp1->datasend($_[2]);
			$tmp1->dataend();
			$tmp1->quit();
		}

		&_logging(4,"Server => " . $tmp2[0]->exchange . ", From $_[0], To: $_[1]");

	}

}


##
## Subject Ver1.00
##
sub _subject {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	$tmp1 = join('','A' .. 'Z','a' .. 'z',0 .. 9) . "+/";
	$tmp2 = $_[0];

	&code(\$tmp2,'jis','euc');

	$tmp2 =~ s/\x1b\x28\x42/\x1b\x28\x4a/go;
	$tmp2 = unpack("B*", $tmp2);

	for ($tmp5 = 0; $tmp3 = substr($tmp2, $tmp5, 6); $tmp5 += 6) {
		$tmp4 .= substr($tmp1, ord(pack("B*", "00" . $tmp3)), 1);
		if (length($tmp3) == 2) {
			$tmp4 .= "==";
		} elsif (length($tmp3) == 4) {
			$tmp4 .= "=";
		}
	}

	chomp ($tmp4);
	return("=?iso-2022-jp?B?$tmp4?=");

}

##
## Code Ver1.02
##
sub code {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);

	if (!$init{'code'}) {

		$init{'code'} = 1;

		if ($SET{'NKF'}) {
			if (&_use($SET{'NKF'})) {
				$init{'code'} = 2;
				&error($TEXT{'ERROR_MSG_NKF'});
			}
		} elsif ($SET{'JCODE'}) {
			eval ("require \"$SET{'JCODE'}\"");
			if ($@) {
				$init{'code'} = 2;
				&error($TEXT{'ERROR_MSG_JCODE'});
			}
		}

		if ($in{'cc'}) {
			if ($in{'cc'} =~ /\xA5\xB3\xA1\xBC\xA5\xC9/) {
				$code[2] = 'euc';
			} elsif ($in{'cc'} =~ /\x83\x52\x81\x5B\x83\x68/) {
				$code[2] = 'sjis';
			} elsif ($in{'cc'} =~ /\x25\x33\x21\x3C\x25\x49/) {
				$code[2] = 'jis';
#			} elsif ($in{'cc'} =~ /\x30\xB3\x30\xFC\x30\xC9/) {
#				$code[2] = 'utf8';
			} else {
				&error($TEXT{'ERROR_MSG_ENCODE'});
			}
		}

	}

	if ($init{'code'} == 1) {

		$tmp1 = $_[2] || $code[2];

		if ($SET{'NKF'}) {
			${$_[0]} = NKF::nkf("--$_[1] --$tmp1-input",${$_[0]});
		} elsif ($SET{'JCODE'}) {
			&jcode::convert($_[0],$_[1],$tmp1,'z');
		}

	}

}

sub _form {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined ($return = &plugin(undef,@_))) { return $return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4);

	$tmp1 = $1;
	$tmp2 = $2;
	$tmp3 = $4;
	$tmp4 = $5;

	$tmp4 =~ s/<select (.*?)name=(["']?)(.*?)\2(.*?)>(.*?)<\/select>/&_form_select/egos;
	$tmp4 =~ s/<input (.*?)name=(["']?)(.*?)\2(.*?)>/&_form_input/egos;
	$tmp4 =~ s/<textarea (.*?)name=(["']?)(.*?)\2(.*?)>(.*?)<\/textarea>/&_form_textarea/egos;

	return "<form " . $tmp1 . "action=" . $tmp2 . $cgi . $tmp2 . $tmp3 . ">" . $tmp4 . "</form>";

}

sub _form_input {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined ($return = &plugin(undef,@_))) { return $return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	$tmp1 = "<input $1name=$2$3$2$4>";
	$tmp2 = $1;
	$tmp3 = $2;
	$tmp4 = $3;
	$tmp5 = $4;

	if (($tmp2 =~ /type=(["']?)text/o || $tmp5 =~ /type=(["']?)text/o) || ($tmp2 !~ /type/o && $tmp5 !~ /type/o)) {
		return &_form_text($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	} elsif ($tmp2 =~ /type=(["']?)submit/o || $tmp5 =~ /type=(["']?)submit/o) {
		return $tmp1;
	} elsif ($tmp2 =~ /type=(["']?)hidden/o || $tmp5 =~ /type=(["']?)hidden/o) {
		return &_form_hidden($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	} elsif ($tmp2 =~ /type=(["']?)checkbox/o || $tmp5 =~ /type=(["']?)checkbox/o) {
		return &_form_checkbox($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	} elsif ($tmp2 =~ /type=(["']?)radio/o || $tmp5 =~ /type=(["']?)radio/o) {
		return &_form_radio($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	} else {
		return $tmp1;
	}

}

sub _form_hidden {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined ($return = &plugin(undef,@_))) { return $return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	($tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = @_;

	if (defined $in{$tmp4}) {
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//goi;
		$tmp1 =~ s/(\/)?>/ value="$in{$tmp4}" \/>/io;
	}

	undef @_;
	return $tmp1;

}

sub _form_checkbox {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined ($return = &plugin(undef,@_))) { return $return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	($tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = @_;

	if (defined $in{$tmp4}) { $tmp1 =~ s/ checked(=(["']?)checked\2)?//gio; }
	foreach (@{$in{$tmp4}}) {
		if ($tmp1 =~ / value=(["']?)$_\1/gio || $tmp1 !~ / value=(["']?).*\1/gio) {
			$tmp1 =~ s/(\/)?>/ checked="checked" \/>/io;
			last;
		}
	}

	undef @_;
	return $tmp1;

}

sub _form_radio {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined ($return = &plugin(undef,@_))) { return $return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	($tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = @_;

	if (defined $in{$tmp4}) {
		$tmp1 =~ s/ checked(=(["']?)checked\2)?//gio;
		if ($tmp1 =~ / value=(["']?)$in{$tmp4}/gio) {
			$tmp1 =~ s/(\/)?>/ checked="checked" \/>/io;
		}
	}


	undef @_;
	return $tmp1;

}


sub _form_text {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined ($return = &plugin(undef,@_))) { return $return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);

	($tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = @_;

	if (defined $in{$tmp4}) {
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//gio;
		$tmp1 =~ s/>/ value="$in{$tmp4}">/io;
	} elsif ($in{'m'} && $tmp4 eq 'title') {
		&_analysis(\%form,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$in{'m'}");
		$form{'title'} = $form{'full_title'};
		if ($form{'title'} =~ s/^Re\^(\d+): //o) {
			$tmp6 = "Re^" . ($1 + 1) . ": $form{'title'}";
		} elsif ($form{'title'} =~ s/^Re: //o) {
			$tmp6 = "Re^2: $form{'title'}";
		} else {
			$tmp6 = "Re: $form{'title'}";
		}
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//gio;
		$tmp1 =~ s/(\/)?>/ value="$tmp6" \/>/io;
	}

	undef @_;
	return $tmp1;

}

sub _form_textarea {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined ($return = &plugin(undef,@_))) { return $return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	$tmp1 = "<textarea $1name=$2$3$2$4>$in{$3}</textarea>";
	$tmp2 = $2;
	$tmp3 = $3;

	undef @_;
	return $tmp1;

}

sub _form_select {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined ($return = &plugin(undef,@_))) { return $return; }

	my ($tmp1,$tmp2);

	$tmp1 = "<select $1name=$2$3$2$4>$5</select>";
	$tmp2 = $3;

	if ($in{$tmp2}) {
		$tmp1 =~ s/ selected(=(["']?)selected\2)?//gio;
		$tmp1 =~ s/<(option (.*?)value=(["']?)$in{$tmp2}\3(.*?))>/<$1 selected="selected">/gio;
	}

	undef @_;
	return $tmp1;

}

##
## HTTP TIME Ver1.00
##
## HTTPǻȤλ֤֤
sub _http_time {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my (@tmp1,@tmp2,@tmp3);

	@tmp1 = gmtime($_[0]);
	@tmp2 = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	@tmp3 = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');


	return sprintf("%s, %02d\ %s\ %04d %02d\:%02d\:%02d GMT",$tmp2[$tmp1[6]],$tmp1[3],$tmp3[$tmp1[4]],$tmp1[5]+1900,$tmp1[2],$tmp1[1],$tmp1[0]);

}

##
## COOKIE TIME Ver1.00
##
## COOKIEǻȤλ֤֤
sub _cookie_time {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my (@tmp1,@tmp2,@tmp3);

	@tmp1 = gmtime($_[0]);
	@tmp2 = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
	@tmp3 = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');


	return sprintf("%s, %02d\-%s\-%04d %02d\:%02d\:%02d GMT",$tmp2[$tmp1[6]],$tmp1[3],$tmp3[$tmp1[4]],$tmp1[5]+1900,$tmp1[2],$tmp1[1],$tmp1[0]);

}

sub _set_cookie {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3);
	$tmp1 = &_cookie_time($time + $SET{'COOKIE_TIME'});

	foreach (sort keys %in) {
		if ($_ =~ /^(f|id|title|message|t|m|cc|confirm|plugin)$/) { next; }
		$tmp2 = $in{$_};
		$tmp2 =~ s/([\W\%\+\;\,\=\&\_\:])/'%' . unpack("H2",$1)/ego;
		$tmp3 .= "$_:$tmp2,";
	}
	undef @_;
	return "Set-Cookie: B.Forum:$in{'id'}=$tmp3; expires=$tmp1\n";

}

sub _get_cookie {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);
	my (@tmp3);
	foreach $tmp1 (split(/;\s*/,$ENV{'HTTP_COOKIE'})) {
		if ((split(/=/,$tmp1))[0] eq "B.Forum:$in{'id'}") {
			&code(\$tmp1,'euc');
			foreach $tmp2 (split(/,\s*/,(split(/=/,$tmp1))[1])) {
				@tmp3 = split(/:/,$tmp2);
				$tmp3[1] =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;
				$in{$tmp3[0]} = $tmp3[1];
			}
			last;
		}
	}

}

sub _lock {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3);

	if (!$do->{lock} || open (LOCK,"$SET{'USER_DIR'}/$in{'id'}/lock")) {
		binmode (LOCK);
		$tmp1 = <LOCK>;
		close (LOCK);
		chomp ($tmp1);
		$tmp2 = 0;
		foreach (1 .. $SET{'LOCK_RETRY'}) {
			if (($time - $tmp1) > $SET{'LOCK_FREE'}) {
				$tmp2 = 1;
				last;
			} else {
				sleep (1);
			}
		}
	} else {
		$tmp2 = 1;
	}

	if ($tmp2 || $do->{lock}) {
		open (LOCK,">$SET{'USER_DIR'}/$in{'id'}/lock");
		binmode (LOCK);
		print LOCK $time;
		close(LOCK);
		$tmp3 = 1;
	} else {
		$notice = "$TEXT{'ERROR_MSG_POST_CLASH'}\n";
	}

	$do->{lock} = $tmp3;
	return $tmp3;

}

sub _unlock {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	unlink ("$SET{'USER_DIR'}/$in{'id'}/lock");


}

sub _analysis {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);

	$tmp1 = shift (@_);

	$tmp2 = &_open(undef,@_);
	($tmp2,$tmp3) = split(/\n\n/,$tmp2,2);
	foreach (split(/\n/,$tmp2)) {
		if ($_ =~ /^\s*(.+?):\s+(.*?)\s*$/o) {
			$tmp4 = lc $1;
			$$tmp1{$tmp4} = $2;
		}
	}

	if ($$tmp1{'type'} ne 'text/html') {
		$tmp6 = &_br($tmp3);
	} else {
		$tmp6 = $tmp3;
	}

	if (!$$tmp1{'title'}) { $$tmp1{'title'} = "(̵)"; }

	$$tmp1{'full_title'} = $$tmp1{'title'};
	if ($SET{'TITLE_LENGTH'}) {
		$$tmp1{'title'} = &_cut($$tmp1{'full_title'},$SET{'TITLE_LENGTH'},'...');
	}

	$$tmp1{'message'} = $tmp6 || "";

	foreach (split(",",$$tmp1{'files'})) {
		$$tmp1{$_} =~ s/^.*[\\\/\:]([^\\\/\:]+)$/$1/go;
	}

	foreach (keys %$tmp1) {
		$$tmp1{$_} =~ s/{/\\{/go;
	}


	undef @_;
	return ($$tmp1{'no'},$$tmp1{'title'},$$tmp1{'author'},$$tmp1{'email'},$$tmp1{'date'},$$tmp1{'message'});

}

##
## BR Ver1.01
##
## $aβԤ򥿥ˤ
## Ǥ̵뤹
## $A = &_br($a);
sub _br {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }
	my ($tmp1,$tmp2);

	foreach (split(/\n/,$_[0])) {
		if ($_ =~ /<.*[^\/]>/o) { $tmp1++; }
		if ($_ =~ /<\/.*>/o) { $tmp1--; }
		if ($_ !~ /^[\s\t]*<.*>[\s\t]*$/ && !$tmp1) { $_ .= "\n<br />"; }
		$tmp2 .= $_ . "\n";
	}


	return $_[0] = $tmp2;

}

##
## Cut Ver1.03
##
## $a$bڤ$cĤ
## $A = &_cut($a,$b[,$c]);
sub _cut {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3);

	$tmp1 = $_[0];
	$tmp2 = $_[1];

	if (!(length ($tmp1) > $_[1])) {

		return $_[0];

	} else {

		$tmp3 = substr($tmp1,0,$tmp2);
		if ($tmp3 =~ /^(.+)[\s\t\xa1-\xfe]/) {

			## ññ̤ڤФ
			$tmp3 = $1;

		} else {

			## ڡ or ̵֤
			while ($tmp3 !~ /[\s\t]/ && length($tmp1) > $tmp2) {

				$tmp2++;
				$tmp3 = substr($tmp1,0,$tmp2);

			}

		}

		## EUCθüΥߤ
		if (($tmp3 =~ /([\xa1-\xfe]+)$/o && length($1) % 2) || $tmp1 =~ /\x8f$/o) { $tmp3 = substr($tmp1,0,(length($tmp1) - 1)); }

		return $tmp3 . $_[2];

	}

}

##
## Wrap Ver1.00
##
sub _wrap {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);
	my (@tmp3);

	$_[1]++;
	foreach (split("\n",$_[0])) {
		$tmp1 = $_;
		while (length $tmp1 > $_[1]) {
			$tmp2 = &_cut($tmp1,$_[1]);
			push (@tmp3,$tmp2);
			substr($tmp1,0,length($tmp2),"");
		}
		push (@tmp3,$tmp1);
	}


	return @tmp3;

}

##
## CrossSiteScripting Ver.1.00
##
sub _xss {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	$_[0] =~ s/(<.*?=(["']?))(.*?)(\2.*?>)/$1 . &__xss($3) . $4/ego;
	$_[0] =~ s/&(?!\w+;)/&amp;$1/go;
#	$_[0] =~ s/&amp;(\w+;)/&$1/go;

}

sub __xss {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);

	$tmp1 = $_[0];
	$tmp1 =~ s/</&lt;/go;
	$tmp1 =~ s/>/&gt;/go;
	$tmp1 =~ s/"/&quot;/go;


	return $tmp1;

}

sub _xhtmlcheck {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	$_[0] =~ s/<(\w+)([^>]*)>/&__xhtmlcheck/ego;

	return $_[0];

}

sub __xhtmlcheck {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);
	my (@tmp3);

	$tmp1 = $1;
	$tmp2 = $2;

	## ex.
	## checked -> checked="checked"
	$tmp2 =~ s/(\s)([^=\s]+)(\s)/$1$2="$2"$3/go;

	## ex.
	## width=100 -> width="100"
	$tmp2 =~ s/(\s)(\w+=)([\w\d\.\~\-\/\?\&\+\=\:\@\%\;\#\%]+)/$1$2"$3"/go;

	## ex.
	## <IMG SRC= -> <img src=
	$tmp2 =~ s/(\W)(\w+)(=?.*\W)/$1 . lc($2) . $3/ego;

	$tmp1 .= $tmp2;

#	@tmp3 = ('area','base','basefont','col','br','hr','img','input');
	@tmp3 = split(',',lc($SET{'ATAG'}));

	foreach (@tmp3) {
		if ($tmp1 =~ /^$_/i) {
			if ($tmp1 =~ /\/$/o) {
				return "<$tmp1>";
			} else {
				return "<$tmp1 />";
			}
		}
	}


	return "<$tmp1>";

}

sub tag {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	foreach (split(/,/,lc($SET{'PTAG'}))) {
		$_[0] =~ s/&lt;$_(.*?)&gt;(.*?)&lt;\/$_&gt;/&_tag('p')/egis;
	}

	foreach (split(/,/,lc($SET{'ATAG'}))) {
		$_[0] =~ s/&lt;$_(.*?)&gt;/&_tag('a')/egi;
	}

}

sub _tag {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);
	$tmp1 = $1;
	$tmp2 = $2;

	$tmp1 =~ s/&amp;/&/go;
	$tmp1 =~ s/&lt;/</go;
	$tmp1 =~ s/&gt;/>/go;
	$tmp1 =~ s/&quot;/"/go;

	$tmp1 =~ s/ href=(["']?)(.*)\1/ $browser->{href}=$1$2$1 target="_blank"/go;
	$tmp1 =~ s/ on\w+=(["']?)(.*)\1//gio;
	if ($_[0] eq 'p') {
		undef @_;
		$tmp2 =~ s/\n<br>\n/\n/go;
		return "<$_$tmp1>$tmp2<\/$_>";
	}
	if ($_[0] eq 'a') {
		undef @_;
		if (!$tmp1 =~ /\/$/o) { $tmp1 .= " /"; }
		return "<$_$tmp1>";
	}

}

sub _hyperlink {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	$_[0] =~ s/<a([^>]+)$browser->{href}=(["']?)$_[1]\2>(.+)<\/a>/<a$1$browser->{href}=$2$_[2]$2>$3<\/a>/gio;

}

##
## Link Ver1.01
##
sub _link {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	return ('<a ' . $browser->{href} . '="' . $cgi . '?' . $_[0] . '">' . $_[1] . '</a>');

}

##
## Autolink Ver1.01
##
sub _autolink {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	$_[0] =~ s/([^=^\"^'^>]|^)(http\:\/\/[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%]+)\.(gif|jpg|png)/$1<a $browser->{href}=\"$2\.$3\" target="_blank"><img src=\"$2\.$3\" border="0" \/><\/a>/go;
	$_[0] =~ s/([^=^\"^'^>]|^)(http\:\/\/[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%]+)/$1<a $browser->{href}=\"$2\" target="_blank">$2<\/a>/go;
	$_[0] =~ s/([^=^\"^'^>]|^)([\w\-_]+)\@([\w\.\-]+)/$1<a $browser->{href}=\"mailto:$2\@$3\">$2\@$3<\/a>/go;
	$_[0] =~ s/([^=^\"^'^>]|^)&gt;&gt;(\d+)/$1<a $browser->{href}=\"$cgi?id=$in{'id'}&t=$in{'t'}&m=$2\">&gt;&gt;$2<\/a>/go;

}

sub _transpose {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	$print{'new_thread:url'} = "$cgi?id=$in{'id'}&f=f";
	$print{'help:url'} = "$cgi?Help&id=$in{'id'}";
	$print{'res:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&f=f";
	$print{'post:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&f=f";
	$print{'old:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&m=1";
	$print{'new:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&m=$message{'number'}";
	$print{'list:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&m=list&s=$in{'s'}";
	$print{'tree:url'} = "$cgi?id=$in{'id'}&t=$in{'t'}&m=tree&s=$in{'s'}";
	$print{'top:url'} = "$cgi?$in{'id'}";

	$print{'new_thread'} = &_link("id=$in{'id'}&f=f",$TEXT{'DISP_NEW_THREAD'});
	$print{'help'} = &_link("Help&id=$in{'id'}",$TEXT{'DISP_HELP'});
	$print{'res'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$in{'m'}&f=f",$TEXT{'DISP_RES'});
	$print{'post'} = &_link("id=$in{'id'}&t=$in{'t'}&f=f",$TEXT{'DISP_POST'});
	$print{'first'} = &_link("id=$in{'id'}&t=$in{'t'}&m=1",$TEXT{'DISP_FIRST'});
	$print{'last'} = &_link("id=$in{'id'}&t=$in{'t'}&m=$message{'number'}",$TEXT{'DISP_LAST'});
	$print{'list'} = &_link("id=$in{'id'}&t=$in{'t'}&m=list&s=$in{'s'}",$TEXT{'DISP_LIST'});
	$print{'tree'} = &_link("id=$in{'id'}&t=$in{'t'}&m=tree&s=$in{'s'}",$TEXT{'DISP_TREE'});
	$print{'top'} = &_link("$in{'id'}",$TEXT{'DISP_TOP'});

	&change($_[0],\%print);
	undef %print;


}

sub status {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my (@tmp1);

	if (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/index")) {

		&_analysis(\%status,"$SET{'USER_DIR'}/$in{'id'}/last");

		$status{'thread'} = 0;
		$status{'log'} = 0;
		$status{'date'} ||= ($time - int((-M "$SET{'USER_DIR'}/$in{'id'}/index") * 86400));
		foreach (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/index")) {

			chomp($_);
			if (!&_open('file',"$SET{'USER_DIR'}/$in{'id'}/$_/1")) { next; }

			$status{'thread'} ++;
			$status{'log'} += &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$_/list") + 1;
		}

		$tmp1[0] = "Thread: $status{'thread'}\n";
		$tmp1[1] = "Log: $status{'log'}\n";
		$tmp1[2] = "Date: $status{'date'}\n";

		&_write("$SET{'USER_DIR'}/$in{'id'}/status",@tmp1);

	}


}

##
## Plugin Ver1.02
## ץ饰¹Ԥ
## $print = &plugin($pluginname);
sub plugin {

	## Ƶɻ
	if ($donot->{'plugin'}) { return; }
	$donot->{'plugin'} = 1;

	local($altitude) = $altitude + 1;

#	&_logging(7);

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	my (@tmp6);
	$tmp1 = shift @_;
	$tmp1 ||= (caller(1))[3];
	$tmp1 =~ s/^.*:://;

	if (!$SET{'PLUGIN_DIR'}) {
		## Ƶɻ߲
		$donot->{'plugin'} = 0;
		return;
	}

	if ($tmp1 eq "init") {

		## Initialize
		opendir(DIR,$SET{'PLUGIN_DIR'});
		@tmp6 = readdir(DIR);
		closedir(DIR);

		foreach (sort @tmp6) {

			if ($_ =~ /^(.+)\.pm$/) {

				$tmp1 = $1;

				if (eval("require \"$SET{'PLUGIN_DIR'}/$tmp1.pm\"") && ($plugin->{$tmp1}->{'object'} = eval("Bforum::Plugin::$tmp1->new(in => \\\%in, SET => \\\%SET, TEXT => \\\%TEXT,);")) && eval("\$plugin->{$tmp1}->{'object'}->require(\$VERSION,\$REVISION);")) {
					foreach (eval("\@Bforum::Plugin::${tmp1}::METHOD")) {
						push(@{$plugin->{'method'}->{$_}},$tmp1);
					}
					$doplugin{$tmp1} = "Initialize $tmp1\@$SET{'PLUGIN_DIR'}/$_";
				} else {
					delete ${$plugin}{$tmp1};
					$WARNING{"Plugin: $tmp1"} = "version missmatch or status is failed";
				}

			}

		}

	} else {

		## Υե󥹤ʤ鷫֤
		if (ref $tmp1) {
			foreach (@$tmp1) {
				&plugin($_);
			}
			return;
		}

		foreach $tmp5 (@{$plugin->{'method'}->{$tmp1}}) {

			no strict;

			open (NULL,undef);
			$tmp2 = select (NULL);

			undef $@;
			$tmp3 = eval("\$plugin->{$tmp5}->{'object'}->args(in => \\\%in, SET => \\\%SET, TEXT => \\\%TEXT, head => \\\$head, foot => \\\$foot,) && \$plugin->{$tmp5}->{'object'}->$tmp1(\@_);");

			if ($@) {
				$WARNING{"Plugin: $tmp5 $tmp1"} = $@;
			} elsif (defined $tmp3) {
				$doplugin{"$tmp5 $tmp1"} = eval("\$plugin->{$tmp5}->{'object'}->version();");
				$tmp4 .= $tmp3;
				last;
			} elsif (!defined $tmp3) {
				undef $tmp4;
			}

			select ($tmp2);
			close (NULL);

			undef $tmp3;

		}

		$print .= $tmp4;

	}

	## Ƶɻ߲
	$donot->{'plugin'} = 0;

	return $tmp4;

}

sub limit {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);

	undef $tmp1;

	map { $_ =~ tr/0-9//cd; } ($SET{'LIMIT_THREAD'},$SET{'LIMIT_THREAD_ITEM'},$SET{'LIMIT_CAPACITY'},$SET{'LIMIT_ITEM'});

	if (defined $SET{'LIMIT_THREAD'} || defined $SET{'LIMIT_THREAD_ITEM'} || defined $SET{'LIMIT_CAPACITY'} || defined $SET{'LIMIT_ITEM'}) {
		if (!$tmp1 && defined $SET{'LIMIT_THREAD'} && !$in{'t'}) {

			&_analysis(\%status,"$SET{'USER_DIR'}/$in{'id'}/status");
			if (!($status{'thread'} && $status{'log'} && $status{'date'})  && -f "$SET{'USER_DIR'}/$in{'id'}/index") { &status; }
			$tmp2 = $status{'thread'};

			if ($SET{'LIMIT_THREAD'} <= $tmp2) { $tmp1 = 1; }

		}
		if (!$tmp1 && defined $SET{'LIMIT_THREAD_ITEM'} && $in{'t'} && $SET{'LIMIT_THREAD_ITEM'} <= (&_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list") + 1)) {
			$tmp1 = 1;
		}
		if (!$tmp1 && defined $SET{'LIMIT_CAPACITY'} || defined $SET{'LIMIT_ITEM'}) {

			undef $tmp3;
			undef $tmp4;

			foreach $tmp5 (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/index")) {
				chomp($tmp5);
				if (!-f "$SET{'USER_DIR'}/$in{'id'}/$tmp5/1" && !-f "$SET{'USER_DIR'}/$in{'id'}/$tmp5.bfa")  {
					next;
				} elsif (-f "$SET{'USER_DIR'}/$in{'id'}/$tmp5.bfa") {
					$tmp3 += (-s "$SET{'USER_DIR'}/$in{'id'}/$tmp5.bfa");
					$tmp4 += (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/$tmp5/list") || 1);
				} else {

					foreach $tmp6 (&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$tmp5/list") || 1) {
						if ($SET{'SECTORSIZE'}) {
							$tmp3 += ((int((-s "$SET{'USER_DIR'}/$in{'id'}/$tmp5/$tmp6")/$SET{'SECTORSIZE'})) + 1) * $SET{'SECTORSIZE'};
						} else {
							$tmp3 += (-s "$SET{'USER_DIR'}/$in{'id'}/$tmp5/$tmp6");
						}
					}
					$tmp4 += (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/$tmp5/list") || 1);

				}
			}
			if (defined $SET{'LIMIT_CAPACITY'} && $SET{'LIMIT_CAPACITY'} <= $tmp3) {
				$tmp1 = 1;
			} elsif (defined $SET{'LIMIT_ITEM'} && $SET{'LIMIT_ITEM'} <= $tmp4) {
				$tmp1 = 1;
			}

		}

	}


	return $tmp1;

}

##
## TIME Ver1.00
##
sub _time {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);
	my (@tmp2);

	$ENV{'TZ'} = $TEXT{'TIME_ZONE'} || "JST-9";
	@tmp2 = localtime($_[0]);
	$tmp1 = $_[1] || $TEXT{'TIME_FORMAT'};
	$tmp1 =~ s/%ss/sprintf("%02d",$tmp2[0])/ego;
	$tmp1 =~ s/%s/$tmp2[0]/go;
	$tmp1 =~ s/%mm/sprintf("%02d",$tmp2[1])/ego;
	$tmp1 =~ s/%m/$tmp2[1]/go;
	$tmp1 =~ s/%HH/{ if (($tmp2[2] - 12) > 0) { sprintf("%02d",($tmp2[2] - 12)); } else { sprintf("%02d",$tmp2[2]); } }/ego;
	$tmp1 =~ s/%H/{ if (($tmp2[2] - 12) > 0) { ($tmp2[2] - 12); } else { $tmp2[2]; } }/ego;
	$tmp1 =~ s/%hh/sprintf("%02d",$tmp2[2])/ego;
	$tmp1 =~ s/%h/$tmp2[2]/go;
	$tmp1 =~ s/%AP/(split(',',$TEXT{'AP_FORMAT'}))[(($tmp2[2] - 12) > 0)]/ego;
	$tmp1 =~ s/%DD/sprintf("%02d",$tmp2[3])/ego;
	$tmp1 =~ s/%D/$tmp2[3]/go;
	$tmp1 =~ s/%MF/(split(',',$TEXT{'MONTH_FORMAT'}))[($tmp2[4])]/ego;
	$tmp1 =~ s/%MM/sprintf("%02d",($tmp2[4] + 1))/ego;
	$tmp1 =~ s/%M/{$tmp2[4] + 1}/ego;
	$tmp1 =~ s/%YYYY/sprintf("%04d",($tmp2[5] + 1900))/ego;
	$tmp1 =~ s/%YY/sprintf("%02d",substr($tmp2[5],-1,2))/ego;
	$tmp1 =~ s/%w/(split(',',$TEXT{'WEEK_FORMAT'}))[($tmp2[6])]/ego;

	if (defined wantarray) {
		return $tmp1;
	} else {
		$_[0] = $tmp1;
		return $tmp1;
	}

}

sub _default {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	$thread ||= 0;
	$log ||= 0;
	$date ||= &_time(0);
	$id ||= $in{'id'};
	undef @_;


}

sub _replace {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	${$_[0]} =~ s/<\!-- $_[1] --> (.+?) <\!-- $_[1] -->/<\!-- $_[1] --> $_[2] <\!-- $_[1] -->/gs;
	undef @_;

}

##
## BF Ver1.02
##
sub _bfopen {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	return &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$_[0]$browser->{'browser'}$browser->{'language'}","$SET{'USER_DIR'}/$in{'id'}/$_[0]$browser->{'browser'}","$SET{'USER_DIR'}/$in{'id'}/$_[0]$browser->{'language'}","$SET{'USER_DIR'}/$in{'id'}/$_[0]","$SET{'USER_DIR'}/$_[0]$browser->{'browser'}","$SET{'USER_DIR'}/$_[0]$browser->{'browser'}","$SET{'USER_DIR'}/$_[0]$browser->{'language'}","$SET{'USER_DIR'}/$_[0]",);

}

##
## Open Ver1.02
##
sub _open {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3);
	my (@tmp4,@tmp5);

	($tmp1,@tmp4) = @_;

	foreach (@tmp4) {

		$tmp2 = $_;
		$tmp2 =~ s/\/+/\//go;
		$tmp2 =~ s/;.*$//go;

		if (defined @{$cache->{'file'}->{$tmp2}}) {

			last;

		} else {

			if ($tmp2 !~ /^>/) {
				@{$cache->{'file'}->{$tmp2}} = &_archive(0,$tmp2);
				&_logging(6,"archive open $tmp2");
			}

			if ($tmp2 =~ /^>/o || -r $tmp2) {

				open (FILE,$tmp2) || next;
				binmode (FILE);
				@{$cache->{'file'}->{$tmp2}} = (<FILE>);
				close (FILE);
				&_logging(6,"file open $tmp2");

				## Do command that in file.
				foreach (@{$cache->{'file'}->{$tmp2}}) {
					if ($_ =~/^#(.+)\s+(.+)\s+$/o) {
						if ($1 eq 'include') {
							## include
							if ($2 ne (split('/',$tmp2))[-1]) {
								@tmp5 = split('/',$tmp2);
								$_ = &_open(undef,join('/',splice(@tmp5,0,-1)) . "/$2");
							}
						}
					}
				}

				last;

			}

		}

	}


	if ($tmp1 eq 'file') {
		## First argument is 'file'.
		return @{$cache->{'file'}->{$tmp2}};
	} elsif ($tmp1 eq 'line') {
		## First argument is 'line'.
		if (!join('',@{$cache->{'file'}->{$tmp2}})) {
			## File is 0byte.
			return 0;
		} else {
			return $tmp3 = @{$cache->{'file'}->{$tmp2}};
		}
	} else {
		if (defined $tmp1) {
			## First argument is number.
			return $cache->{'file'}->{$tmp2}->[$tmp1];
		} else {
			return join('',@{$cache->{'file'}->{$tmp2}});
		}
	}

}

##
## Path Ver1.02
##
sub _path {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);

	if (!$init{'cwd'}) {
		use Cwd;
		$init{'cwd'} = 1;
	}

	$tmp1 = $_[0];

	## Macintoshк
	$tmp1 =~ tr/\\:/\//s;

	if ($tmp1 !~ /^(\/|~|\w\/|:)/) {
		$tmp1 = Cwd::cwd() . "/" . $tmp1;
		$tmp1 =~ s/\/\.\//\//go;
		while ($tmp1 =~ /[^\/]+\/\.\.\//o) {
			$tmp1 =~ s/[^\/]+\/\.\.\///go;
		}
	}

	## Windowsк
	$tmp1 =~ s/^(\w)\/\//$1:\//;


	return $tmp1;

}

sub _flush {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	undef @{$cache->{'file'}->{$_[0]}};

}

##
## Cache 1.02
##
sub _cache {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);

	## ߤΥåΥ
	opendir (DIR,"$SET{'USER_DIR'}/.cache");
	foreach (readdir(DIR)) {
		$tmp2 += (-s "$SET{'USER_DIR'}/.cache/$_")
	}
	closedir (DIR);

	if ($SET{'CACHE_DO'} ne 'N' && $ENV{'QUERY_STRING'} && $tmp2 < $SET{'LIMIT_CACHE'} && !$donot->{cache}) {
		## å
		$tmp1 = join('&',@QUERY);
		$tmp1 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
		$init{'error'} = 1;
		&_write(("$SET{'USER_DIR'}/.cache/$tmp1$browser->{'language'}$browser->{'browser'}"),$print);
	}

}

sub _cache_flush {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);
	my (@tmp2);

	opendir (CACHE,"$SET{'USER_DIR'}/.cache");
	@tmp2 = readdir(CACHE);
	closedir (CACHE);
	foreach (@tmp2) {
		if ($_ eq '.' || $_ eq '..') { next; }
		if ($in{'id'}) {
			$tmp1 = $in{'id'};
			$tmp1 =~ s/(\W)/'%' . unpack("H2",$1)/ego;
			if ($_ =~ /(^|\&)(id%3d)?$tmp1/i) { unlink("$SET{'USER_DIR'}/.cache/$_"); }
		} else {
			unlink("$SET{'USER_DIR'}/.cache/$_");
		}
	}


}

sub _diskwrite {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3);
	my (@tmp4,@tmp5);

	&_logging(6,"files are " . keys %{$write});

	foreach (keys %{$write}) {

		$tmp1 = $_;
		@tmp5 = @{$cache->{file}->{$_}};

		undef $tmp2;

		if ($tmp1 =~ /$SET{'USER_DIR'}\/$in{'id'}\/$in{'t'}\/.+$/o && (!-d "$SET{'USER_DIR'}/$in{'id'}/$in{'t'}" || $tmp1 =~ /BF..+$/o)) {
			($tmp2) = &_archive(1,$tmp1,(join('',@tmp5)));
		}
		if (!$tmp2 || !(!-d "$SET{'USER_DIR'}/$in{'id'}/$in{'t'}" || $tmp1 =~ /BF..+$/o)) {
			@tmp4 = split('/',$tmp1);
			pop(@tmp4);
			$tmp3 = join('/',@tmp4);
			if ($tmp3 && !-d $tmp3) {
				umask (oct($SET{'UMASK'}));
				mkdir ($tmp3,0777) || &error($tmp3);
			}
			open (FILE,">$tmp1.tmp") || &error;
			binmode (FILE);
			print FILE @tmp5;
			close (FILE);
			if (-f $tmp1) { unlink ($tmp1) || &error; }
			rename ("$tmp1.tmp",$tmp1) || &error;
		}

		delete ${$write}{$_};

	}

	undef @_;

}

sub _write {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3);
	my (@tmp4);
	$tmp1 = shift(@_);

	@{$cache->{file}->{$tmp1}} = @_;
	$write->{$tmp1} = 1;

	&_logging(6,"wrote $tmp1($cache->{file}->{$tmp1})");

	undef @_;


}

##
## Archive Ver1.02
##
## ֥եμ갷
## 񤭹
## $filename = &_archive(1,$filename,$data)
## ɤ߹
## @data = &_archive(0,$filename)

sub _archive {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4);
	my (@tmp5,@tmp6);

	if ($_[1] =~ /^(.+)\/(index|last|status|.bforumrc|.bforumrc.cache|.+\.bfa)$/o) {
		return;
	} elsif ($_[1] =~ /^(.+)\/(BF\..+)$/o) {
		$tmp2 = "$1/BF.bfa";
		$tmp3 = $2;
	} elsif ($_[1] =~ /^(.+)\/(.+?)$/o) {
		$tmp1 = $1;
		$tmp3 = $2;
		if ($2 =~ /(list)/o) {
			$tmp2 = "$tmp1.0.bfa";
		} elsif ($2 =~ /\D/) {
			$tmp2 = "$tmp1.bfa";
		} else {
			$tmp2 = "$tmp1." . int($2 / 10) . ".bfa";
		}
	} else {
		return;
	}

	if (!$init{'archive'} && (($_[0] && $SET{'ARCHIVE_DO'} ne 'N') || (!$_[0] && -f $tmp2))) {
		if ($SET{'ARCHIVE_TAR'} || !-x $SET{'ARCHIVE_TAR'}) {
			if (&_use("Archive::Tar")) {
				return;
			}
		}
		$init{'archive'} = 1;
	}

	if (!$init{'archive'}) {
		return;
	}

	## Archive::Tar
	if ($cache->{'archive'}->{$tmp2}) {
		$tmp4 = $cache->{'archive'}->{$tmp2};
	} else {
		$tmp4 = Archive::Tar->new();
		if (-f $tmp2) {
			$tmp4->read($tmp2,1);
		}
		$cache->{'archive'}->{$tmp2} = $tmp4;
	}

	if ($_[0] && $SET{'ARCHIVE_DO'} ne 'N') {

		## 񤭹
		$tmp4->remove($tmp3);
		$tmp4->add_data($tmp3,$_[2]);
		if ($SET{'COMPRESS_DO'} ne 'N') {
			&_compress($tmp2,$tmp4->write());
		} else {
			$tmp4->write($tmp2);
		}
		@tmp5 = ($tmp2);

	} elsif (-f $tmp2) {

		## ɤ߹
		@tmp5 = split(/\n/,$tmp4->get_content($tmp3));
		if (@tmp5) {
			map { $_ .= "\n"; } @tmp5;
		}

	} else {
		return;
	}



	return @tmp5;

}

##
## Compress Ver1.02
##
## 񤭹
## $data = &_compress($filename,$data)
## ɤ߹
## $data = &_compress($filename)

sub _compress {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);

	if ($SET{'COMPRESS_DO'} ne 'N') {

		if (!$init{'compress'}) {
			if (&_use("Compress::Zlib")) {
				return;
			}
			$init{'compress'} = 1;
		}

		if (defined $_[1]) {

			## 񤭹
			$tmp1 = Compress::Zlib::gzopen($_[0],"wb");
			if ($SET{'COMPRESS_LEVEL'}) {
				## СˤäƤѰդƤʤs
				eval("$tmp1->gzsetparams($SET{'COMPRESS_LEVEL'})");
			}
			$tmp1->gzwrite($_[1]);

		} else {

			## ɤ߹
			$tmp1 = Compress::Zlib::gzopen($_[0],"rb");
			$tmp1->gzread($tmp2);

		}

		$tmp1->gzclose;

		return $tmp2;

	} else {

		return;

	}


}


##
## Do Ver1.01
##
sub do {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	$_[0] =~ s/(\\*)<%(.+?)(\\*)%>/&_do/egios;

}

sub _do {

	local($altitude) = $altitude + 1;

	&_logging(7);

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	no strict;

	if (length($1) % 2 || length($3) % 2) {
		$tmp1 = $1 . '<%' . $2 . $3 . '%>';
	} else {
		$tmp2 = $1;
		$tmp3 = $2;
		$tmp4 = $3;
		$tmp3 =~ s/(\W)print(\W)/$1\$tmp5 .=$2/go;
		eval ($tmp3);
		$tmp1 = $tmp2 . $tmp5 . $@ . $tmp4;
	}

	undef @_;
	return $tmp1;

}

##
## Change Ver1.02
##
sub change {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	$_[0] =~ s/(\\*)(\w*){(.+?)}/&_change($_[1])/ego;

}

sub _change {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7);

	$tmp2 = $1;
	$tmp3 = $2;
	$tmp4 = $3;

	no strict;

	if (length($tmp2) % 2) {
		$tmp1 = $tmp2 . $tmp3 . '{' . $tmp4 . '}';
	} else {

		if ($tmp4 =~ /^(\,?)(.+?)$/o) {
			$tmp5 = $1;
			$tmp4 = $2;
		}

		if ($tmp4 =~ /^(.+?)\((.+?)\)$/o) {
			$tmp4 = $1;
			$tmp6 = $2;
		}

		if ($_[0]) {
			if (${$_[0]}{$tmp4}) {
				$tmp7 = $tmp3 . ${$_[0]}{$tmp4};
			} elsif (defined ${$_[0]}{$tmp4}) {
				$tmp7 = $tmp3;
			} else {
				if ($tmp5) {
					$tmp4 = "," . $tmp4;
				}
				if ($tmp6) {
					$tmp4 = $tmp4 . "($tmp6)";
				}
				$tmp7 = $tmp3 . '{' . $tmp4 . '}';
				undef $tmp5;
				undef $tmp6;
			}
		} else {
			if (${$tmp4}) {
				$tmp7 = $tmp3 . ${$tmp4};
			} elsif (defined ${$tmp3}{$tmp4}) {
				$tmp7 = ${$tmp3}{$tmp4};
			} elsif (defined *tmp4) {
				$tmp7 = $tmp3;
			} else {
				if ($tmp5) {
					$tmp4 = "," . $tmp4;
				}
				if ($tmp6) {
					$tmp4 = $tmp4 . "($tmp6)";
				}
				$tmp7 = $tmp3 . '{' . $tmp4 . '}';
				undef $tmp5;
				undef $tmp6;
			}
		}

		if ($tmp5) {
			$tmp7 = &_comma($tmp7);
		}

		if ($tmp6) {

			$tmp7 =~ s/<.+?>//go;
			$tmp7 =~ s/\&lt;.+?\&gt;//go;
			$tmp7 =~ s/\n//gio;
			$tmp1 = $tmp2 . &_cut($tmp7,$tmp6,'...');

		} else {

			$tmp1 = $tmp2 . $tmp7;

		}

	}

	undef @_;
	return $tmp1;

}

sub _indexcheck {

	local($altitude) = $altitude + 1;

	&_logging(7);

	my ($return);

	$return = &plugin(undef,@_);
	if (defined $return) { return $return; }

	my ($tmp1,$tmp2);

	undef $tmp2;
	foreach $tmp1 (&_open('file',"$SET{'USER_DIR'}/$_[0]/index")) {

		chomp($tmp1);
		if (!-d "$SET{'USER_DIR'}/$_[0]/$tmp1" && !-f "$SET{'USER_DIR'}/$_[0]/$tmp1.0.bfa") { next; }

		if ($tmp1 eq $in{'t'}) {
			$tmp2 = "";
			last;
		}

	}


	return $tmp2;

}

sub _listcheck {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);

	if ($_[2] eq '1') {
		return 1;
	}

	undef $tmp2;
	foreach $tmp1 (&_open('file',"$SET{'USER_DIR'}/$_[0]/$_[1]/list")) {

		chomp ($tmp1);
		if ($tmp1 =~ /^#/o) { next; }

		if ((split(/<0>/,$tmp1))[0] eq $_[2]) {
			$tmp2 = 1;
			last;
		}

	}

	undef @_;
	return $tmp2;

}

##
## Reflexive Ver1.01
##
sub _reflexive {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my (@tmp1,@tmp2);

	opendir (DIR,$_[0]);
	@tmp1 = readdir(DIR);
	closedir (DIR);
	foreach (sort @tmp1) {
		if ($_ =~ /\.{1,2}$/o) { next; }
		if (-s "$_[0]/$_/index") {
			push (@tmp2,"$_[0]/$_");
		}
		if (-d "$_[0]/$_") {
			push (@tmp2,&_reflexive("$_[0]/$_"));
		}
	}


	return @tmp2;

}

##
## Logging Ver1.00
##
sub _logging {

	## 0:EMERG   ѥ˥å
	## 1:ALERT   н
	## 2:CRIT    ʥ顼
	## 3:ERR     顼
	## 4:WARNING ٹ
	## 5:NOTICE  
	## 6:INFO    
	## 7:DEBUG   ǥХå

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3);

	if (!$init{'log'}) {

		## ʸ
		$d2s = {
			0 => "EMERG",
			1 => "ALERT",
			2 => "CRIT",
			3 => "ERR",
			4 => "WARNING",
			5 => "NOTICE",
			6 => "INFO",
			7 => "DEBUG",
		};

		## ʸ
		foreach (keys %{$d2s}) {
			$s2d->{$d2s->{$_}} = $_;
		}

		$init{'log'} = 1;

	}

	## ƵŪʥΥå
	if ($donot->{log}) { return; }

	if ($SET{'LOG_LEVEL'} && ($loglevel->[$tmp2] > $s2d->{$SET{'LOG_LEVEL'}})) { return; }

	$tmp1 = sprintf("$$ %-24s %-7s %-5s \[%s %s\@%s\] %s\n",(scalar localtime(time)),$d2s->{$_[0]},(caller(0))[2],(" " x $altitude),(caller(1))[3],(caller(1))[1],$_[1]);

	## Хåե¸
	push(@{$logging},$tmp1);
	$loglevel->[$#{$logging}] = $_[0];

	## Ƶɻ
	$donot->{log} = 1;

	$tmp2 = 0;
	while($logging->[$tmp2]) {

		$tmp3 = $logging->[$tmp2];

		if ($loglevel->[$tmp2] <= $s2d->{$SET{'LOG_LEVEL'}}) {

			&_write(($SET{"LOG_FILE_$d2s->{$loglevel->[$tmp2]}"} || $SET{'LOG_FILE'}),&_open(undef,($SET{"LOG_FILE_$d2s->{$loglevel->[$tmp2]}"} || $SET{'LOG_FILE'})),$tmp3);

			## ɸ२顼
			print STDERR $tmp3;

			splice(@{$logging},$tmp2,1);
			splice(@{$loglevel},$tmp2,1);

		} else {

			$tmp2++;

		}

	}

	## Ƶɻ߲
	$donot->{log} = 0;

}

##
## Use Ver1.01
##
sub _use {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	if (!defined $init{$_[0]}) {
		eval ("use $_[0]");
		$init{$_[0]} = $@;
	}


	return $init{$_[0]};

}

##
## Comma Ver1.02
##
sub _comma {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);

	$tmp1 = $_[0];
	while ($tmp1 =~ s/(.*\d)(\d{3})/$1,$2/) {
	}

	return $tmp1;

}

##
## AddTitle Ver1.02
##
## ȥʸä
## &addtitle(String);
sub addtitle {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	$title .= $_[0];

}

sub browser {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7,$tmp8);

	$tmp1 = &_bfopen("BF.browser");

	$tmp1 =~ s/[^\\]#.*\n//go;

	foreach $tmp2 ($tmp1 =~ /\n*([^\n]*?:[^:]*)\n/gos) {
		$tmp2 =~ s/\n//go;
		$tmp2 =~ /(.*):(.*)/o;

		$tmp3 = $1;
		$tmp4 = $2;
		$tmp4 =~ s/[\n\s]//go;
		foreach $tmp5 ($tmp4 =~ /(.*?=.*?);/go) {
			$tmp5 =~ /(.*?)=(.*)/o;
			$tmp6 = $1;
			$tmp7 = $2;
			$browser->{$tmp3}->{$tmp6} = $tmp7;
		}
		if ($ENV{'HTTP_USER_AGENT'} =~ /$tmp3/) {
			$tmp8 = $tmp3;
		}
	}

	$browser->{'content'} = $browser->{$tmp8}->{'content'} || $browser->{'Default'}->{'content'};
	$browser->{'href'} = $browser->{$tmp8}->{'href'} || $browser->{'Default'}->{'href'};
	@code = split(',',($browser->{$tmp8}->{'code'} || $browser->{'Default'}->{'code'}));
	$browser->{'browser'} = $browser->{$tmp8}->{'browser'} || $browser->{'Default'}->{'browser'};


}

##
## Check Ver1.01
##
sub check {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);

	## ADDRESS
	$check->{'Address'}->{'status'} = "OK";
	$check->{'Address'}->{'value'} = $SET{'ADDRESS'};
	if ($SET{'ADDRESS'} !~ /^.+\@.+\..+$/) {
		$check->{'Address'}->{'status'} = "NG";
	}

	## USER_DIR
	$check->{'User directory'}->{'status'} = "OK";
	$check->{'User directory'}->{'value'} = &_path("$SET{'USER_DIR'}/");
	if (!-d $SET{'USER_DIR'}) {
		$check->{'User directory'}->{'status'} = "NG";
		$check->{'User directory'}->{'value'} = "Not found:<strong>" . &_path($SET{'USER_DIR'}) . "</strong>";
	} elsif (!-r $SET{'USER_DIR'} || !-w $SET{'USER_DIR'} || !-x $SET{'USER_DIR'}) {
		$check->{'User directory'}->{'status'} = "NG";
		$check->{'User durectory'}->{'value'} = "Permission denied:<strong>" . &_path($SET{'USER_DIR'}) . "</strong>";
	}

	## 
	if ($in{'id'} ne 'Check') {

		## ȥǥ쥯ȥ
		$check->{'Data directory'}->{'status'} = "OK";
		$check->{'Data directory'}->{'value'} = &_path("$SET{'USER_DIR'}/$in{'id'}/");
		if (!-d "$SET{'USER_DIR'}/$in{'id'}") {
			$check->{'Data directory'}->{'status'} = "NG";
			$check->{'Data directory'}->{'value'} = "Not found:<strong>" . &_path("$SET{'USER_DIR'}/$in{'id'}") . "</strong>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}" || !-w "$SET{'USER_DIR'}/$in{'id'}" || !-x "$SET{'USER_DIR'}/$in{'id'}") {
			$check->{'Data directory'}->{'status'} = "NG";
			$check->{'Data directory'}->{'value'} = "Permission denied:<strong>" . &_path("$SET{'USER_DIR'}/$in{'id'}") . "</strong>";
		}

		## indexեγǧ
		$check->{'Index file'}->{'status'} = "OK";
		$check->{'Index file'}->{'value'} = &_path("$SET{'USER_DIR'}/$in{'id'}/index");
		if (!-d "$SET{'USER_DIR'}/$in{'id'}") {
			$check->{'Index file'}->{'status'} = "NG";
			$check->{'Index file'}->{'value'} = "Not found:<strong>" . &_path("$SET{'USER_DIR'}/$in{'id'}/index") . "</strong>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}/index" || !-w "$SET{'USER_DIR'}/$in{'id'}/index") {
			$check->{'Index file'}->{'status'} = "NG";
			$check->{'Index file'}->{'value'} = "Permission denied:<strong>" . &_path("$SET{'USER_DIR'}/$in{'id'}/index") . "</strong>";
		}

	}

	## Sendmail
	$check->{'Sendmail'}->{'status'} = "OK";
	($tmp1,undef) = split(/\s/,$SET{'SENDMAIL'});
	$check->{'Sendmail'}->{'value'} = $SET{'SENDMAIL'};
	if (!-e $tmp1) {
		$check->{'Sendmail'}->{'status'} = "NG";
		$check->{'Sendmail'}->{'value'} = "Not found:<b>$tmp1</b>";
	} elsif (!-x $tmp1 && !-r $tmp1) {
		$check->{'Sendmail'}->{'status'} = "NG";
		$check->{'Sendmail'}->{'value'} = "Permission denied:<b>$tmp1</b>";
	}

	foreach (
		{item => "Do sendmail",set => "SENDMAIL_DO"},
		{item => "Do portal",set => "PORTAL_DO"},
		{item => "Do check",set => "CHECK_DO"},
		{item => "Do archive",set => "ARCHIVE_DO"},
		{item => "Do compress",set => "COMPRESS_DO"},
		{item => "Do cache",set => "CACHE_DO"},
		{item => "Do fileupload",set => "FILE_UPLOAD_DO"},
	) {
		$check->{$_->{'item'}}->{'status'} = "Yes";
		$check->{$_->{'item'}}->{'value'} = "Value OK";
		if ($SET{$_->{'set'}} eq 'N') {
			$check->{$_->{'item'}}->{'status'} = "No";
		} elsif ($SET{$_->{'set'}} ne 'Y') {
			$check->{$_->{'item'}}->{'value'} = "Illegal value:<b>$SET{$$_{'set'}}</b>";
		}
	}

	$check->{'User name'}->{'status'} = "OK";
	$check->{'User name'}->{'value'} = getlogin;

	$check->{'Default Language'}->{'status'} = "OK";
	$check->{'Default Language'}->{'value'} = $SET{'LANGUAGE'};

	## BF.*եγǧ
	foreach ("BF.about","BF.browser","BF.confirm","BF.delete","BF.email","BF.email.error","BF.foot","BF.form","BF.help","BF.head","BF.index","BF.index.foot","BF.index.head","BF.list","BF.list.foot","BF.list.head","BF.notice","BF.portal","BF.regist","BF.thread","BF.thread.foot","BF.thread.head","BF.tree","BF.tree.foot","BF.tree.head","BF.message") {
		$check->{$_}->{'status'} = "OK";
		if (!-f "$SET{'USER_DIR'}/$in{'id'}/$_" && !-f "$SET{'USER_DIR'}/$_" && !-f "$SET{'USER_DIR'}/$in{'id'}/BF.bfa" && !-f "$SET{'USER_DIR'}/BF.bfa") {
			## ե뤬̵
			$check->{$_}->{'status'} = "NG";
			$check->{$_}->{'value'} = "Not found<b>$_</b>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}/$_" && !-r "$SET{'USER_DIR'}/$_" && !-r "$SET{'USER_DIR'}/$in{'id'}/BF.bfa" && !-r "$SET{'USER_DIR'}/BF.bfa") {
			## ѡߥå󤬴ְäƤ
			$check->{$_}->{'status'} = "NG";
			$check->{$_}->{'value'} = "Permission denied:<b>$_</b>";
		} else {
			if (-f "$SET{'USER_DIR'}/$in{'id'}/$_" && -r "$SET{'USER_DIR'}/$in{'id'}/$_") {
				## ե(ȥե/BF.*)
				$check->{$_}->{'value'} = &_path("$SET{'USER_DIR'}/$in{'id'}/$_");
			} elsif (-f "$SET{'USER_DIR'}/$_" && -r "$SET{'USER_DIR'}/$_") {
				## ե(Хե/BF.*)
				$check->{$_}->{'value'} = &_path("$SET{'USER_DIR'}/$_");
			} elsif (&_open('line',"$SET{'USER_DIR'}/$in{'id'}/$_")) {
				## ե(ȥե/BF.bfa)
				$check->{$_}->{'value'} = &_path("$SET{'USER_DIR'}/$in{'id'}/BF.bfa");
			} elsif (&_open('line',"$SET{'USER_DIR'}/$_")) {
				## ե(Хե/BF.*)
				$check->{$_}->{'value'} = &_path("$SET{'USER_DIR'}/BF.bfa");
			} else {
				## Ϥե뤬̵
				$check->{$_}->{'status'} = "NG";
				$check->{$_}->{'value'} = "Not found<b>$_</b>";
			}
		}
	}

	## jcode.plNKFγǧ
	$check->{'Code filter'}->{'status'} = "OK";
	if ($init{'code'}) {
		if ($SET{'NKF'}) {
			$check->{'Code filter'}->{'value'} = "$SET{'NKF'}";
		} elsif ($SET{'JCODE'}) {
			$check->{'Code filter'}->{'value'} = &_path($SET{'JCODE'});
		}
	} else {
		$check->{'Code filter'}->{'status'} = "NG";
	}

	$tmp2 = 0;
	foreach (sort keys %{$check}) {
		$check->{$_}->{'value'} ||= "&nbsp;";
		if ($check->{$_}->{'status'} eq 'NG') {
			$check->{$_}->{'status'} = "<b style=\"color:#ff0000\">NG</b>";
			$tmp2 ++;
		}
		$print .= "<tr>	<th>$_</th>	<th>$check->{$_}->{'status'}</th>	<td>$check->{$_}->{'value'}</td>	</tr>\n";
	}
	$print = "<b>$tmp2</b> of status are NG.\n<table border=\"1\">$print</table>\n";


	if (-f "$SET{'USER_DIR'}/$in{'id'}/index") { &status; }

	undef @_;

}

sub help {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1);

	$tmp1 = &_bfopen("BF.help");

	&change($tmp1,\%print);
	undef %print;

	&do($tmp1);

	$print = $tmp1;

	$donot->{cache} = 1;


}

##
## Language Ver1.02
##
sub language {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my (%tmp1);

	foreach (split(/,\s*?/,lc($ENV{'HTTP_ACCEPT_LANGUAGE'}))) {
		if ($_ =~ /^(\w+).*;q=(.*)$/) {
			$tmp1{$1} = $2;
			&_logging(7,"$1;q=$2");
		} elsif ($_ =~ /^(\w+?)$/) {
			$tmp1{$1} ||= 1;
			&_logging(7,"$1;q=1.0");
		}
	}

	&setting(\%TEXT,"$SET{'USER_DIR'}/.language/$SET{'LANGUAGE'}");
	&setting(\%TEXT,"$SET{'USER_DIR'}/$in{'id'}/.language/$SET{'LANGUAGE'}");
	foreach (sort { $tmp1{$b} <=> $tmp1{$a} } keys %tmp1) {
		if (-f "$SET{'USER_DIR'}/$in{'id'}/.language/$_" || -f "$SET{'USER_DIR'}/.language/$_") {
			$browser->{language} = ".$_";
			&setting(\%TEXT,"$SET{'USER_DIR'}/.language/$_");
			&setting(\%TEXT,"$SET{'USER_DIR'}/$in{'id'}/.language/$_");
			&_logging(6,"Language: $_");
			last;
		}
	}

}

##
## Setting Ver1.01
##
sub setting {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);
	$tmp1 = shift @_;
	foreach (@_) {
		if (-f $_) {
			foreach $tmp2 (&_open('file',$_)) {
				chomp ($tmp2);
				if ($tmp2 =~ /^\s*#/o) { next; }
				($tmp2) = split (/#\s+/,$tmp2);
				($tmp2) = split (/\s+#/,$tmp2);
				if (!$tmp2) { next; }
				if ($tmp2 =~ /^\s*([^\s]+?)\s+(.*?)\s*$/gio) {
					${$tmp1}{uc($1)} = $2;
				} elsif ($tmp2 =~ /^\s*([^\s]+?)\s*$/gio) {
					${$tmp1}{uc($1)} = "";
				}
			}
			last;
		}
	}
	return;

}

##
## Decode Ver1.02
##
sub decode {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7,$tmp8,$tmp9,$tmp10);
	$tmp1 = $ENV{'REQUEST_METHOD'};
	$tmp2 = $ENV{'QUERY_STRING'};
	$tmp3 = $ENV{'CONTENT_LENGTH'};

	if ($tmp1 eq "POST") {
		binmode(STDIN);
		read(STDIN, $tmp7, $tmp3);
	} elsif ($tmp1 eq 'HEAD') {
		$tmp7 = $tmp2;
		$donot->{body} = 1;
	} else {
		$tmp7 = $tmp2;
	}

	$tmp7 ||= $ARGV[0];
	if (!($tmp7 =~ /\&|=/)) {
		$in{'id'} = $tmp7;
	}

	## For multipart formdata(Fileupload)
	if ($ENV{'CONTENT_TYPE'} =~ /^multipart\/form-data; boundary=-*(.*)$/) {
		$tmp4 = $1;
		foreach (split(/-*$tmp4-*[(\r\n)\n\r]+/,$tmp7)) {
			($tmp5,$tmp6) = split(/\r\n\r\n|\n\n|\r\r/,$_,2);
			$tmp6 =~ s/[(\r\n)\n\r]$//go;
			if ($tmp5 =~ s/Content-Disposition: form-data; name=(["^]*)(.*?)\1; filename=(["^]*)(.*?)\3[(\r\n)\n\r]+//) {
				push (@QUERY,"$2=$4");
				if ($tmp6 !~ /^[(\r\n)\n\r]?$/) {
					$files{$2} = "$tmp5\n";
					$files{$2} .= "Accept-Ranges: bytes\n";
#					$files{$2} .= "Content-Length: " . length($tmp6) . "\n"; # Apache for Winꤢ
					$files{$2} .= "Last-Modified: " . &_http_time(time) . "\n";
					$files{$2} .= "\n";
					$files{$2} .= $tmp6;
				}
			} elsif ($tmp5 =~ /Content-Disposition: form-data; name=(["^]*)(.*?)\1/) {
				push (@QUERY,"$2=$tmp6");
			}
		}
	} else {
		$tmp7 =~ tr/+/ /;
		@QUERY = split('&', $tmp7);
	}

	push (@QUERY,@ARGV);

	foreach (@QUERY) {

		if (index($_,"=") < 0) { next; }

		($tmp8,$tmp9) = split(/=/, $_, 2);
		$tmp8 =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;
		$tmp9 =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;

		if ($tmp8 =~ /confirm\.(.+)$/o) {
			$tmp8 = $1;
			$tmp9 =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;
		} elsif ($tmp8 =~ /file\.(.+)/o) {
			$tmp8 = $1;
			$tmp9 =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;
			$files{$tmp8} = $tmp9;
			next;
		}

		$tmp9 =~ s/&/&amp;/go;
		$tmp9 =~ s/</&lt;/go;
		$tmp9 =~ s/>/&gt;/go;
		$tmp9 =~ s/"/&quot;/go;
		$tmp9 =~ s/\r\n?/\n/go;
		$tmp9 =~ s/\\/\\\\/go;

		if ($in{$tmp8} && $tmp8 ne 'id') {
			$tmp10 = $in{$tmp8};
			undef $in{$tmp8};
			push(@{$in{$tmp8}},$tmp10,$tmp9);
		} else {
			$in{$tmp8} = $tmp9;
		}

	}

}

sub error {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	if ($init{'error'}) { exit(1); }
	$init{'error'} = 1;
	$donot->{cache} = 1;

	$error = {
		"01" => {
			key => "ERROR CODE",
			value => (caller)[2] . '@' . (caller)[1]
		},
		"02" => {
			key => "PID",
			value => $$
		},
		"03" => {
			key => "UID",
			value => $<
		},
		"04" => {
			key => "EUID",
			value => $>
		},
		"05" => {
			key => "GID",
			value => $(
		},
		"06" => {
			key => "EGID",
			value => $)
		},
		"07" => {
			key => "OS NAME",
			value => $^O
		},
		"08" => {
			key => "PROGRAM NAME",
			value => $0
		},
		"09" => {
			key => "PERL VERSION",
			value => $]
		},
		"10" => {
			key => "DEBUGGING",
			value => $^A
		},
		"11" => {
			key => "BASETIME",
			value => $^T
		},
		"12" => {
			key => "EXEC NAME",
			value => $^X
		},
	};

	$email{'error_code'} = $error->{'01'}->{value};

	undef $print;

	&change($_[0]);
	if ($_[0]) { $print .= "<b>ERROR:</b> $_[0]\n<br>\n<br>\n"; }
	$print .= "$TEXT{'ERROR_1'}\n<br>\n";
	$print .= "$TEXT{'ERROR_2'}\n<br>\n";
	$print .= "<table border=1 style=\"font-size:smaller\">\n";
	foreach (sort keys %{$error}) {
		$print .= "<tr><th>$error->{$_}->{key}</th><td>$error->{$_}->{value}</td></tr>\n";
		$email{'error'} .= sprintf("%-20s%-s\n",$error->{$_}->{key},$error->{$_}->{value});
	}
	foreach (sort keys %SET) {
		$email{'setting'} .= sprintf("%-20s%-s\n",$_,$SET{$_});
	}
	foreach (sort keys %in) {
		my ($tmp1);
		$tmp1 = uc ($_);
		$print .= "<tr><th>$tmp1</th><td>$in{$_}</td></tr>\n";
		$email{'query'} .= sprintf("%-20s%-s\n",$tmp1,$in{$_});
	}
	foreach (sort keys %ENV) {
		$email{'env'} .= sprintf("%-25s%-s\n",$_,$ENV{$_});
	}
	$print .= "</table>";

	$email{'url'} = $url;
	&sendmail(&_bfopen("BF.email.error"),\%email);

	$print =~ s/\\/\\\\/go;

	&print;

	&_exit(0);


}

sub print {

	local($altitude) = $altitude + 1;

	&_logging(7);

	$head = &_bfopen("BF.head") || "<html><head><title></title></head><body>";
	$foot = &_bfopen("BF.foot") || "</body></html>";

	if (defined &plugin(undef,@_)) { return; }

	my ($tmp1,$tmp2);

	if (!$donot->{head}) { $print = $head . $print . $foot; }
	&_default;

#	$notice .= &_bfopen("BF.notice");
#	$notice =~ s/(.+?)\n/<li>$1<\/li>\n/go;
#	$notice = "\n<ul>\n" . $notice . "\n</ul>\n";

	&change($print,\%TEXT);

	&_analysis(\%status,"$SET{'USER_DIR'}/$in{'id'}/status");
	if (!($status{'thread'} && $status{'log'} && $status{'date'}) && -f "$SET{'USER_DIR'}/$in{'id'}/index") { &status; }
	if ($print =~ /{date:(.+?)}/o) { $status{"date:$1"} = &_time($status{'date'},$1); }
	&_time($status{'date'});
	&change($print,\%status);
	&_replace(\$print,'THREAD',$status{'thread'});
	&_replace(\$print,'LOG',$status{'log'});
	&_replace(\$print,'DATE',$status{'date'});
	&_replace(\$print,'VERSION',$VERSION);
	&_replace(\$print,'ADDRESS',"<a $browser->{href}=\"mailto:" . $SET{'ADDRESS'} . '">' . $SET{'ADDRESS'} . '</a>');

	&do($print);
	&_transpose($print);
	&change($print);
	$print =~ s/(<form .*?action=(["']?)($cgi|{cgi})\2.*?>)(.*?)\n/$1$4\n<div><input type="hidden" name="id" value="$in{'id'}" \/>\n<input type="hidden" name="t" value="$in{'t'}" \/>\n<input type="hidden" name="m" value="$in{'m'}" \/>\n<input type="hidden" name="f" value="r" \/>\n<input type="hidden" name="cc" value="" \/><\/div>\n/gio;
	$print =~ s/<form (.*?)action=(["']?)($cgi|{cgi})\2(.*?)>(.*?)<\/form>/&_form/egios;
	$print =~ s/\\{/\{/go;
#	$print =~ s/([^\\])\\([^\\])/$1$2/go;
	$print =~ s/\\\\/\\/go;

	## Cross Site Scripting
	&_xss($print);

	if ($code[1]) { &code(\$print,$code[1],'euc'); }

	$tmp2 = "<!-- Time: " . (sprintf "%.2f", ((times)[0] - $time{'start'})) . " -->\n";
	$tmp2 .= "<!-- Admin: $SET{'ADDRESS'} -->\n";
	$tmp2 .= "<!-- Version: $REVISION -->\n";
	foreach (keys %WARNING) {
		$WARNING{$_} =~ s/\n//go;
		$tmp2 .= "<!-- Warning: $_ ($WARNING{$_}) -->\n";
		&_logging(4,"$_ ($WARNING{$_}), http://$url");
	}
	foreach (keys %doplugin) {
		$tmp2 .= "<!-- Plugin: $_ ($doplugin{$_}) -->\n";
	}
	if ($SET{'CACHE_DO'} ne 'N' && $ENV{'QUERY_STRING'} && !$donot->{cache}) {
		$tmp2 .= "<!-- Cache: " . &_http_time($time) . " -->\n";
	}

	$print =~ s/(<\w.*>)/$1\n$tmp2/;

	select (STDOUT);

	$title = " $title";
	## ȯ(B)
	$print =~ s/<title(.*?)>(.*?)<\/title>/<title$1>B.Forum : $2$title - $VERSION(Revision:$REVISION)<\/title>/i;

	$header .= "Content-Type: $browser->{content}; charset=$code[0]\n";
	$header .= "Accept-Ranges: bytes\n";
#	$header .= "Content-Length: " . length($print) . "\n"; #Apache for Winꤢ
	$header .= "Last-Modified: " . &_http_time($time) . "\n";
	$print = $header . "\n" . $print;

	if ($donot->{body}) {

		print $header . "\n";

	} elsif(!$donot->{print}) {

		print $print;

	}

	&_cache;

	undef @_;

}

##
## _exit Ver1.00
##
## exit򤹤
## ƤӽФʤХեν񤭹ߤ⤷ʤ
## ʰץХåư
sub _exit {

	local($altitude) = $altitude + 1;

	&_logging(7);

	if (defined &plugin(undef,@_)) { return; }

	&_diskwrite;

	if ($do->{lock}) { &_unlock; }

	exit($_[0]);

}

1;
